=== modified file 'DBUS-API'
--- DBUS-API	2011-11-26 23:08:17 +0000
+++ DBUS-API	2011-03-17 18:14:34 +0000
@@ -5,7 +5,7 @@
 This file documents the D-Bus interface to the Mandos server.
 
 * Bus: System bus
-  Bus name: "se.recompile.Mandos"
+  Bus name: "se.bsnet.fukt.Mandos"
 
 
 * Object Paths:
@@ -17,7 +17,7 @@
 
   
 * Mandos Server Interface:
-  Interface name: "se.recompile.Mandos"
+  Interface name: "se.bsnet.fukt.Mandos"
   
 ** Methods:
 *** GetAllClients() → (ao: Clients)
@@ -44,7 +44,7 @@
 
 
 * Mandos Client Interface:
-  Interface name: "se.recompile.Mandos.Client"
+  Interface name: "se.bsnet.fukt.Mandos.Client"
   
 ** Methods
 *** Approve(b: Approve) → nothing
@@ -86,17 +86,15 @@
    | CheckerRunning (c)      | b    | Read/Write | N/A                 |
    | Created (d)             | s    | Read       | N/A                 |
    | Enabled (e)             | b    | Read/Write | N/A                 |
-   | Expires (f)             | s    | Read       | N/A                 |
-   | ExtendedTimeout (a)     | t    | Read/Write | extended_timeout    |
    | Fingerprint             | s    | Read       | fingerprint         |
    | Host                    | s    | Read/Write | host                |
    | Interval (a)            | t    | Read/Write | interval            |
-   | LastApprovalRequest (g) | s    | Read       | N/A                 |
-   | LastCheckedOK (h)       | s    | Read/Write | N/A                 |
-   | LastEnabled (i)         | s    | Read       | N/A                 |
+   | LastApprovalRequest (f) | s    | Read       | N/A                 |
+   | LastCheckedOK (g)       | s    | Read/Write | N/A                 |
+   | LastEnabled (h)         | s    | Read       | N/A                 |
    | Name                    | s    | Read       | (Section name)      |
    | ObjectPath              | o    | Read       | N/A                 |
-   | Secret (j)              | ay   | Write      | secret (or secfile) |
+   | Secret (i)              | ay   | Write      | secret (or secfile) |
    | Timeout (a)             | t    | Read/Write | timeout             |
    
    a) Represented as milliseconds.
@@ -111,23 +109,20 @@
    e) Setting this property is equivalent to calling Enable() or
       Disable().
    
-   f) The date and time this client will be disabled, as an RFC 3339
-      string, or an empty string if this is not scheduled.
-   
-   g) The date and time of the last approval request, as an RFC 3339
-      string, or an empty string if this has not happened.
-   
-   h) The date and time a checker was last successful, as an RFC 3339
-      string, or an empty string if this has not happened.  Setting
-      this property is equivalent to calling CheckedOK(), i.e. the
-      current time is set, regardless of the string sent.  Please
-      always use an empty string when setting this property, to allow
-      for possible future expansion.
-   
-   i) The date and time this client was last enabled, as an RFC 3339
-      string, or an empty string if this has not happened.
-   
-   j) A raw byte array, not hexadecimal digits.
+   f) The time of the last approval request, as an RFC 3339 string, or
+      an empty string if this has not happened.
+   
+   g) The last time a checker was successful, as an RFC 3339 string,
+      or an empty string if this has not happened.  Setting this
+      property is equivalent to calling CheckedOK(), i.e. the current
+      time is set, regardless of the string sent.  Please always use
+      an empty string when setting this property, to allow for
+      possible future expansion.
+   
+   h) The last time this client was enabled, as an RFC 3339 string, or
+      an empty string if this has not happened.
+   
+   i) A raw byte array, not hexadecimal digits.
 
 ** Signals
 *** CheckerCompleted(n: Exitcode, x: Waitstatus, s: Command)
@@ -152,9 +147,6 @@
 *** Rejected(s: Reason)
     This client was not given its secret for a specified Reason.
 
-*** NewRequest(s: IP address)
-    A client at IP adress has asked for its password.
-
 * Copyright
 
     Copyright © 2010-2011 Teddy Hogeborn

=== modified file 'Makefile'
--- Makefile	2011-11-26 22:22:20 +0000
+++ Makefile	2011-08-08 21:12:37 +0000
@@ -5,7 +5,7 @@
 	-Wbad-function-cast -Wcast-qual -Wcast-align -Wwrite-strings \
 	-Wconversion -Wstrict-prototypes -Wold-style-definition \
 	-Wpacked -Wnested-externs -Winline -Wvolatile-register-var
-#	-Wunreachable-code
+#	-Wunreachable-code 
 #DEBUG=-ggdb3
 # For info about _FORTIFY_SOURCE, see
 # <http://www.kernel.org/doc/man-pages/online/pages/man7/feature_test_macros.7.html>
@@ -23,19 +23,15 @@
 OPTIMIZE=-Os
 LANGUAGE=-std=gnu99
 htmldir=man
-version=1.4.1
+version=1.3.1
 SED=sed
 
-USER=$(firstword $(subst :, ,$(shell getent passwd _mandos || getent passwd nobody || echo 65534)))
-GROUP=$(firstword $(subst :, ,$(shell getent group _mandos || getent group nobody || echo 65534)))
-
 ## Use these settings for a traditional /usr/local install
 # PREFIX=$(DESTDIR)/usr/local
 # CONFDIR=$(DESTDIR)/etc/mandos
 # KEYDIR=$(DESTDIR)/etc/mandos/keys
 # MANDIR=$(PREFIX)/man
 # INITRAMFSTOOLS=$(DESTDIR)/etc/initramfs-tools
-# STATEDIR=$(DESTDIR)/var/lib/mandos
 ##
 
 ## These settings are for a package-type install
@@ -44,7 +40,6 @@
 KEYDIR=$(DESTDIR)/etc/keys/mandos
 MANDIR=$(PREFIX)/share/man
 INITRAMFSTOOLS=$(DESTDIR)/usr/share/initramfs-tools
-STATEDIR=$(DESTDIR)/var/lib/mandos
 ##
 
 GNUTLS_CFLAGS=$(shell pkg-config --cflags-only-I gnutls)
@@ -59,7 +54,7 @@
 CFLAGS=$(WARN) $(DEBUG) $(FORTIFY) $(COVERAGE) $(OPTIMIZE) \
 	$(LANGUAGE) $(GNUTLS_CFLAGS) $(AVAHI_CFLAGS) $(GPGME_CFLAGS) \
 	-DVERSION='"$(version)"'
-LDFLAGS=-Xlinker --as-needed $(COVERAGE) $(LINK_FORTIFY) $(foreach flag,$(LINK_FORTIFY_LD),-Xlinker $(flag))
+LDFLAGS=$(COVERAGE) $(LINK_FORTIFY) $(foreach flag,$(LINK_FORTIFY_LD),-Xlinker $(flag))
 
 # Commands to format a DocBook <refentry> document into a manual page
 DOCBOOKTOMAN=$(strip cd $(dir $<); xsltproc --nonet --xinclude \
@@ -70,9 +65,7 @@
 	--param man.authors.section.enabled	0 \
 	 /usr/share/xml/docbook/stylesheet/nwalsh/manpages/docbook.xsl \
 	$(notdir $<); \
-	$(MANPOST) $(notdir $@);\
-	LANG=en_US.UTF-8 MANWIDTH=80 man --warnings --encoding=UTF-8 \
-	--local-file $(notdir $@) >/dev/null)
+	$(MANPOST) $(notdir $@))
 # DocBook-to-man post-processing to fix a '\n' escape bug
 MANPOST=$(SED) --in-place --expression='s,\\\\en,\\en,g;s,\\n,\\en,g'
 
@@ -235,7 +228,7 @@
 distclean: clean
 mostlyclean: clean
 maintainer-clean: clean
-	-rm --force --recursive keydir confdir statedir
+	-rm --force --recursive keydir confdir
 
 check:	all
 	./mandos --check
@@ -265,8 +258,13 @@
 
 # Run the server with a local config
 run-server: confdir/mandos.conf confdir/clients.conf
-	./mandos --debug --no-dbus --configdir=confdir \
-		--statedir=statedir $(SERVERARGS)
+	@echo "#################################################################"
+	@echo "# NOTE: Please IGNORE the error about \"Could not open file      #"
+	@echo "# u'/var/run/mandos.pid'\" -  it is harmless and is caused by    #"
+	@echo "# the server not running as root.  Do NOT run \"make run-server\" #"
+	@echo "# server as root if you didn't also unpack and compile it thus. #"
+	@echo "#################################################################"
+	./mandos --debug --no-dbus --configdir=confdir $(SERVERARGS)
 
 # Used by run-server
 confdir/mandos.conf: mandos.conf
@@ -277,8 +275,6 @@
 	install --mode=u=rw $< $@
 # Add a client password
 	./mandos-keygen --dir keydir --password >> $@
-statedir:
-	install --directory statedir
 
 install: install-server install-client-nokey
 
@@ -289,8 +285,6 @@
 
 install-server: doc
 	install --directory $(CONFDIR)
-	install --directory --mode=u=rwx --owner=$(USER) \
-		--group=$(GROUP) $(STATEDIR)
 	install --mode=u=rwx,go=rx mandos $(PREFIX)/sbin/mandos
 	install --mode=u=rwx,go=rx --target-directory=$(PREFIX)/sbin \
 		mandos-ctl

=== modified file 'NEWS'
--- NEWS	2011-10-15 16:48:03 +0000
+++ NEWS	2011-07-27 17:58:27 +0000
@@ -1,26 +1,6 @@
 This NEWS file records noteworthy changes, very tersely.
 See the manual for detailed information.
 
-Version 1.4.1 (2011-10-15)
-* Server
-** Make D-Bus properties settable again, and handle checkers
-   for disabled clients correctly.
-* Miscellaneous fixes to "pedantic" Lintian warnings
-
-Version 1.4.0 (2011-10-09)
-* README file migrated to manual page intro(8mandos).
-* Client:
-** Fixed warning about "rmdir: Directory not empty".
-* Server:
-** Default values changed: timeout 5 minutes, interval 2 minutes.
-** Clients gets an expiration extension when receiving a password,
-   controlled by new "extended_timeout" setting.
-** New domain name: "fukt.bsnet.se" changes to "recompile.se".  This
-   also affects the D-Bus bus and interface names (old names still
-   work).  Users should start using the new names immediately.
-** New D-Bus Client object properties "Expires" and "ExtendedTimeout";
-   see DBUS-API for details.
-
 Version 1.3.1 (2011-07-27)
 * Client:
 ** Client now retries all Mandos servers periodically.

=== modified file 'README'
--- README	2011-10-05 16:00:56 +0000
+++ README	2011-08-08 21:12:37 +0000
@@ -1,9 +1,9 @@
-Please see: http://www.recompile.se/mandos/man/intro.8mandos
+Please see: http://www.fukt.bsnet.se/mandos/man/intro.8mandos
 
 This information previously in this file has been moved to the
 intro(8mandos) manual page.  Go to the above URL, or run this command:
 
-	man 8mandos intro
+	make intro.8mandos && man -l intro.8mandos
 
 In short, this is the Mandos system; it allows computers to have
 encrypted root file systems and at the same time be capable of remote

=== modified file 'TODO'
--- TODO	2011-11-09 17:16:03 +0000
+++ TODO	2011-08-08 21:12:37 +0000
@@ -2,8 +2,6 @@
 
 * Use _attribute_((nonnull)) wherever possible.
 
-* [[http://www.undeadly.org/cgi?action=article&sid=20110530221728][OpenBSD]]
-
 * mandos-applet
 
 * mandos-client
@@ -11,12 +9,11 @@
 ** TODO [#B] Use struct sockaddr_storage instead of a union
 ** TODO [#B] Use getaddrinfo(hints=AI_NUMERICHOST) instead of inet_pton()
 ** TODO [#B] Use getnameinfo(serv=NULL, NI_NUMERICHOST) instead of inet_ntop()
-** TODO [#B] Prefer /run/tmp over /tmp, if it exists
 
 * splashy
 ** TODO [#B] use scandir(3) instead of readdir(3)
 
-* usplash (Deprecated)
+* usplash
 ** TODO [#A] Make it work again
 ** TODO [#B] use scandir(3) instead of readdir(3)
 ** TODO Use [[info:libc:Argz%20Functions][argz_extract]]
@@ -41,7 +38,8 @@
 
 * mandos (server)
 ** TODO [#B] Log level							  :BUGS:
-  
+** TODO Persistent state						  :BUGS:
+   /var/lib/mandos/*
 *** TODO /etc/mandos/clients.d/*.conf
     Watch this directory and add/remove/update clients?
 ** TODO [#C] config for TXT record
@@ -52,19 +50,34 @@
    [[info:standards:Option%20Table][Table of Long Options]]
 ** TODO Implement --socket
    [[info:standards:Option%20Table][Table of Long Options]]
+** TODO Date+time on console log messages				  :BUGS:
+   Is this the default?
 ** TODO [#C] DBusServiceObjectUsingSuper
 ** TODO [#B] Global enable/disable flag
 ** TODO [#B] By-client countdown on secrets given
+** TODO [#B] Fix problem with fsck taking a really long time
+   Whenever a client successfully gets a secret it could get a
+   one-time timeout boost to allow for an fsck-incurred delay
+** TODO [#A] Delay before client receives key
+   This would give an operator opportunity to cancel the request if
+   desired.
+** TODO [#A] Client manual approval mode
+   A client needs manual approval on the server before it gets the
+   secret
 ** TODO [#B] Support RFC 3339 time duration syntax
 ** More D-Bus methods
+*** NeedsApproval(50, True) -> timeout, default approve
+    Default approval is configurable, but True by default
+    + Approve(True) -> approve sending saved
+    + Approve(False) -> Close client connection immediately
 *** NeedsPassword(50) - Timeout, default disapprove
     + SetPass(u"gazonk", True) -> Approval, persistent
     + Approve(False) -> Close client connection immediately
 ** TODO [#C] python-parsedatetime
 ** TODO [#C] systemd/launchd
    http://0pointer.de/blog/projects/systemd.html
-   http://wiki.debian.org/systemd
 ** TODO Separate logging logic to own object
+** TODO make clients to a dict!
 ** TODO [#A] Limit approval_delay to max gnutls/tls timeout value
 ** TODO [#B] break the wait on approval_delay if connection dies
 ** TODO Generate Client.runtime_expansions from client options + extra
@@ -78,7 +91,6 @@
 *** Handle "no D-Bus server" and/or "no Mandos server found" better
 *** [#B] --dump option
 ** TODO Support RFC 3339 time duration syntax
-** TODO Send milliseconds if bare integer is passed as time duration
 
 * TODO mandos-dispatch
   Listens for specified D-Bus signals and spawns shell commands with
@@ -94,12 +106,15 @@
 ** Show timeout countdown for approval
 
 * mandos-keygen
+** TODO Loop until passwords match when run interactively
 ** TODO "--secfile" option
    Using the "secfile" option instead of "secret"
 ** TODO [#B] "--test" option
    For testing decryption before rebooting.
 
 * Makefile
+** TODO Add "--Xlinker --as-needed"
+   http://udrepper.livejournal.com/19395.html
 ** TODO [#C] Implement DEB_BUILD_OPTIONS
    http://www.debian.org/doc/debian-policy/ch-source.html#s-debianrules-options
 
@@ -112,8 +127,8 @@
    From XML sources directly?
 
 * Side Stuff
-** TODO Locate which package moves the other bin/sh when busybox is deactivated
-** TODO contact owner of package, and ask them to have that shell static in position regardless of busybox
+** TODO Locate which packet move the other bin/sh when busy box is deactivated
+** TODO contact owner of packet, and ask them to have that shell static in position regardless of busybox
 
 
 #+STARTUP: showall

=== modified file 'clients.conf'
--- clients.conf	2011-11-26 23:08:17 +0000
+++ clients.conf	2010-09-12 03:00:40 +0000
@@ -4,19 +4,14 @@
 
 # How long until a client is disabled and not be allowed to get the
 # data this server holds.
-;timeout = 5m
+;timeout = 1h
 
 # How often to run the checker to confirm that a client is still up.
 # Note: a new checker will not be started if an old one is still
 # running.  The server will wait for a checker to complete until the
 # above "timeout" occurs, at which time the client will be disabled,
 # and any running checker killed.
-;interval = 2m
-
-# Extended timeout is an added timeout that is given once after a
-# password has been sent sucessfully to a client.  This allows for
-# additional delays caused by file system checks and quota checks.
-;extended_timeout = 15m
+;interval = 5m
 
 # What command to run as "the checker".
 ;checker = fping -q -- %%(host)s
@@ -30,9 +25,6 @@
 # How long one approval will last.
 ;approval_duration = 1s
 
-# Whether this client is enabled by default
-;enabled = True
-
 
 ;####
 ;# Example client
@@ -78,7 +70,7 @@
 ;host = 192.0.2.3
 ;
 ;# Parameters from the [DEFAULT] section can be overridden per client.
-;interval = 1m
+;interval = 5m
 ;
 ;# This client requires manual approval before it receives its secret.
 ;approved_by_default = False

=== modified file 'common.ent'
--- common.ent	2011-10-15 16:48:03 +0000
+++ common.ent	2011-07-27 17:58:27 +0000
@@ -1,3 +1,3 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!-- Edited by Makefile -->
-<!ENTITY version "1.4.1">
+<!ENTITY version "1.3.1">

=== modified file 'dbus-mandos.conf'
--- dbus-mandos.conf	2011-10-02 19:18:24 +0000
+++ dbus-mandos.conf	2009-11-09 07:35:16 +0000
@@ -7,18 +7,12 @@
     <allow own="se.bsnet.fukt.Mandos"/>
     <allow send_destination="se.bsnet.fukt.Mandos"/>
     <allow receive_sender="se.bsnet.fukt.Mandos"/>
-    <allow own="se.recompile.Mandos"/>
-    <allow send_destination="se.recompile.Mandos"/>
-    <allow receive_sender="se.recompile.Mandos"/>
   </policy>
   
   <policy user="root">
     <allow own="se.bsnet.fukt.Mandos"/>
     <allow send_destination="se.bsnet.fukt.Mandos"/>
     <allow receive_sender="se.bsnet.fukt.Mandos"/>
-    <allow own="se.recompile.Mandos"/>
-    <allow send_destination="se.recompile.Mandos"/>
-    <allow receive_sender="se.recompile.Mandos"/>
   </policy>
 
 </busconfig>

=== modified file 'debian/changelog'
--- debian/changelog	2011-10-15 16:48:03 +0000
+++ debian/changelog	2011-07-27 17:58:27 +0000
@@ -1,35 +1,3 @@
-mandos (1.4.1-1) unstable; urgency=low
-
-  * New upstream release.
-  * debian/control (Build-Depends): Added "man".
-  * debian/control (Conflicts): Changed to "Breaks:".
-  * debian/copyright: Updated format.
-  * debian/mandos-client.postinst: Use "set -e" instead of "#!/bin/sh -e".
-  * debian/mandos-client.postrm: - '' -
-  * debian/mandos.postinst: - '' -
-  * debian/mandos.prerm: Consistent magic.
-
- -- Björn Påhlsson <belorn@fukt.bsnet.se>  Sat, 15 Oct 2011 18:18:52 +0200
-
-mandos (1.4.0-1) unstable; urgency=low
-
-  * New upstream release.
-  * Fix "FTBFS with binutils-gold": Added "-Xlinker --as-needed" to
-    LDFLAGS in Makefile. (Closes: #632145)
-  * Fix "/run transition: uses obsolete /dev/.initramfs": Try both old and
-    new PID file locations. (Closes: #643554)
-  * debian/source/local-options: New; contains "--single-debian-patch".
-  * debian/control (Standards-Version): Upgraded to "3.9.2".
-    (DM-Upload-Allowed): New; set to "yes".
-  * debian/control: Changed domain from "fukt.bsnet.se" to "recompile.se".
-  * debian/copyright: - '' -
-  * debian/mandos-client.README.Debian: - '' -
-  * debian/mandos.README.Debian: - '' -
-  * debian/watch: - '' -
-  * debian/control (mandos/Description): Fix language to placate lintian.
-
- -- Teddy Hogeborn <teddy@recompile.se>  Sun, 09 Oct 2011 19:15:08 +0200
-
 mandos (1.3.1-1) unstable; urgency=low
 
   * New upstream release.

=== modified file 'debian/control'
--- debian/control	2011-11-26 20:59:56 +0000
+++ debian/control	2011-03-17 18:13:40 +0000
@@ -1,26 +1,24 @@
 Source: mandos
 Section: admin
 Priority: extra
-Maintainer: Mandos Maintainers <mandos@recompile.se>
-Uploaders: Teddy Hogeborn <teddy@recompile.se>,
-	   Björn Påhlsson <belorn@recompile.se>
+Maintainer: Mandos Maintainers <mandos@fukt.bsnet.se>
+Uploaders: Teddy Hogeborn <teddy@fukt.bsnet.se>,
+	   Björn Påhlsson <belorn@fukt.bsnet.se>
 Build-Depends: debhelper (>= 7), docbook-xml, docbook-xsl,
 	libavahi-core-dev, libgpgme11-dev, libgnutls-dev, xsltproc,
-	pkg-config, man
-Standards-Version: 3.9.2
-Vcs-Bzr: http://ftp.recompile.se/pub/mandos/trunk
-Vcs-Browser: http://bzr.recompile.se/loggerhead/mandos/trunk/files
-Homepage: http://www.recompile.se/mandos
-DM-Upload-Allowed: yes
+	pkg-config
+Standards-Version: 3.9.1
+Vcs-Bzr: http://ftp.fukt.bsnet.se/pub/mandos/trunk
+Vcs-Browser: http://bzr.fukt.bsnet.se/loggerhead/mandos/trunk/files
+Homepage: http://www.fukt.bsnet.se/mandos
 
 Package: mandos
 Architecture: all
 Depends: ${misc:Depends}, python (>=2.6), python-gnutls, python-dbus,
 	python-avahi, python-gobject, avahi-daemon, adduser,
-	python-urwid, python (>=2.7) | python-argparse,
-	python-gnupginterface
+	python-urwid, python (>=2.7) | python-argparse
 Recommends: fping
-Description: server giving encrypted passwords to Mandos clients
+Description: a server giving encrypted passwords to Mandos clients
  This is the server part of the Mandos system, which allows
  computers to have encrypted root file systems and at the
  same time be capable of remote and/or unattended reboots.
@@ -39,7 +37,7 @@
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}, adduser, cryptsetup,
 	gnupg (<< 2)
-Breaks: dropbear (<= 0.53.1-1)
+Conflicts: dropbear (<= 0.52-5)
 Enhances: cryptsetup
 Description: do unattended reboots with an encrypted root file system
  This is the client part of the Mandos system, which allows

=== modified file 'debian/copyright'
--- debian/copyright	2011-10-10 20:29:58 +0000
+++ debian/copyright	2011-02-27 17:26:35 +0000
@@ -1,7 +1,8 @@
-Format: http://anonscm.debian.org/viewvc/dep/web/deps/dep5.mdwn?revision=202
+Format-Specification:
+ http://wiki.debian.org/Proposals/CopyrightFormat?action=recall&rev=233
 Upstream-Name: Mandos
-Upstream-Contact: Mandos <mandos@recompile.se>
-Source: <http://www.recompile.se/mandos>
+Upstream-Maintainer: Mandos Maintainers <mandos@fukt.bsnet.se>
+Upstream-Source: <http://www.fukt.bsnet.se/mandos>
 
 Files: *
 Copyright: Copyright © 2008-2011 Teddy Hogeborn

=== modified file 'debian/mandos-client.README.Debian'
--- debian/mandos-client.README.Debian	2011-10-05 16:00:56 +0000
+++ debian/mandos-client.README.Debian	2010-09-27 17:53:53 +0000
@@ -1,3 +1,25 @@
+* Choose the Client Network Interface
+  
+  Please make sure that the correct network interface is specified in
+  the DEVICE setting in the "/etc/initramfs-tools/initramfs.conf"
+  file.  If the setting is empty, the interface will be autodetected
+  at boot time, which may not be correct.  *If* the DEVICE setting is
+  changed, it will be necessary to update the initrd image by running
+  the command
+  
+	update-initramfs -k all -u
+  
+  The device can be overridden at boot time on the Linux kernel
+  command line using the sixth colon-separated field of the "ip="
+  option; for exact syntax, read the documentation in the file
+  "/usr/share/doc/linux-doc-*/Documentation/filesystems/nfsroot.txt",
+  available in the "linux-doc-*" package.
+  
+  Note that since this network interface is used in the initial RAM
+  disk environment, the network interface *must* exist at that stage.
+  Thus, the interface can *not* be a pseudo-interface such as "br0" or
+  "tun0"; instead, a real interface (such as "eth0") must be used.
+
 * Adding a Client Password to the Server
   
   The server must be given a password to give back to the client on
@@ -24,34 +46,6 @@
   it, and output it to standard output.  There it can be verified to
   be the correct password, before rebooting.
 
-* Emergency Escape
-  
-  If it ever should be necessary, the Mandos client can be temporarily
-  prevented from running at startup by passing the parameter
-  "mandos=off" to the kernel.
-
-* Specifying a Client Network Interface
-  
-  At boot time the network interface to use will by default be
-  automatically detected.  If should result in an incorrect interface,
-  edit the DEVICE setting in the "/etc/initramfs-tools/initramfs.conf"
-  file.  (The default setting is empty, meaning to autodetect the
-  interface.)  *If* the DEVICE setting is changed, it will be
-  necessary to update the initrd image by running the command
-  
-	update-initramfs -k all -u
-  
-  The device can be overridden at boot time on the Linux kernel
-  command line using the sixth colon-separated field of the "ip="
-  option; for exact syntax, read the documentation in the file
-  "/usr/share/doc/linux-doc-*/Documentation/filesystems/nfsroot.txt",
-  available in the "linux-doc-*" package.
-  
-  Note that since this network interface is used in the initial RAM
-  disk environment, the network interface *must* exist at that stage.
-  Thus, the interface can *not* be a pseudo-interface such as "br0" or
-  "tun0"; instead, only real interface (such as "eth0") can be used.
-
 * User-Supplied Plugins
   
   Any plugins found in "/etc/mandos/plugins.d" will override and add
@@ -68,14 +62,19 @@
   Mandos client will be the new default way for getting a password for
   the root file system when booting.
 
+* Emergency Escape
+  
+  If it ever should be necessary, the Mandos client can be temporarily
+  prevented from running at startup by passing the parameter
+  "mandos=off" to the kernel.
+
 * Non-local Connection (Not Using ZeroConf)
   
   If the "ip=" kernel command line option is used to specify a
   complete IP address and device name, as noted above, it then becomes
   possible to specify a specific IP address and port to connect to,
   instead of using ZeroConf.  The syntax for doing this is
-  "mandos=connect:<IP_ADDRESS>:<PORT_NUMBER>" on the kernel command
-  line.
+  "mandos=connect:<IP_ADDRESS>:<PORT_NUMBER>".
   
   For very advanced users, it it possible to specify simply
   "mandos=connect" on the kernel command line to make the system only
@@ -84,4 +83,4 @@
   work, "--options-for=mandos-client:--connect=<ADDRESS>:<PORT>" needs
   to be manually added to the file "/etc/mandos/plugin-runner.conf".
 
- -- Teddy Hogeborn <teddy@recompile.se>, Wed,  5 Oct 2011 17:50:22 +0200
+ -- Teddy Hogeborn <teddy@fukt.bsnet.se>, Mon, 27 Sep 2010 19:53:21 +0200

=== modified file 'debian/mandos-client.postinst'
--- debian/mandos-client.postinst	2011-10-10 20:29:58 +0000
+++ debian/mandos-client.postinst	2009-05-24 23:36:15 +0000
@@ -1,4 +1,4 @@
-#!/bin/sh
+#!/bin/sh -e
 # This script can be called in the following ways:
 #
 # After the package was installed:
@@ -15,8 +15,6 @@
 # If prerm fails during replacement due to conflict:
 #       <postinst> abort-remove in-favour <new-package> <version>
 
-set -e
-
 # Update the initial RAM file system image
 update_initramfs()
 {

=== modified file 'debian/mandos-client.postrm'
--- debian/mandos-client.postrm	2011-10-10 20:29:58 +0000
+++ debian/mandos-client.postrm	2011-02-27 17:00:41 +0000
@@ -1,4 +1,4 @@
-#!/bin/sh
+#!/bin/sh -e
 # This script can be called in the following ways:
 #
 # After the package was removed:
@@ -26,7 +26,6 @@
 # If preinst fails during upgrade:
 #       <new-postrm> abort-upgrade <old-version>
 
-set -e
 
 # Update the initial RAM file system image
 update_initramfs()

=== modified file 'debian/mandos.README.Debian'
--- debian/mandos.README.Debian	2011-10-05 16:00:56 +0000
+++ debian/mandos.README.Debian	2009-09-08 06:28:20 +0000
@@ -1,10 +1,10 @@
 The Mandos server is useless without at least one configured client in
 /etc/mandos/clients.conf.  To create one, install the "mandos-client"
-package on a client computer, and, on the client, run the command
+package on a client computer, and run the command
 
 	# mandos-keygen --password
 
-to get a config file stanza.  Append the output of that command to the
-file "/etc/mandos/clients.conf" on the Mandos server computer.
+there to get a config file stanza.  Append the output of that command
+to the file "/etc/mandos/clients.conf" on the Mandos server.
 
- -- Teddy Hogeborn <teddy@recompile.se>, Wed,  5 Oct 2011 17:51:22 +0200
+ -- Teddy Hogeborn <teddy@fukt.bsnet.se>, Tue,  8 Sep 2009 06:57:45 +0200

=== modified file 'debian/mandos.dirs'
--- debian/mandos.dirs	2011-11-26 22:22:20 +0000
+++ debian/mandos.dirs	2010-09-15 17:33:14 +0000
@@ -4,4 +4,3 @@
 etc/default
 etc/dbus-1/system.d
 usr/sbin
-var/lib/mandos

=== modified file 'debian/mandos.postinst'
--- debian/mandos.postinst	2011-11-26 22:22:20 +0000
+++ debian/mandos.postinst	2009-05-24 23:28:04 +0000
@@ -1,4 +1,4 @@
-#!/bin/sh
+#!/bin/sh -e
 # This script can be called in the following ways:
 #
 # After the package was installed:
@@ -15,8 +15,6 @@
 # If prerm fails during replacement due to conflict:
 #       <postinst> abort-remove in-favour <new-package> <version>
 
-set -e
-
 case "$1" in
     configure)
 	# Rename old "mandos" user and group
@@ -35,12 +33,11 @@
 		--disabled-password --gecos "Mandos password system" \
 		_mandos
 	fi
-	chown _mandos:_mandos /var/lib/mandos
 	;;
-    
+
     abort-upgrade|abort-deconfigure|abort-remove)
 	;;
-    
+
     *)
 	echo "$0 called with unknown argument '$1'" 1>&2
 	exit 1

=== modified file 'debian/mandos.prerm'
--- debian/mandos.prerm	2011-10-10 20:29:58 +0000
+++ debian/mandos.prerm	2009-01-18 00:16:57 +0000
@@ -1,4 +1,4 @@
-#!/bin/sh
+#! /bin/sh
 # prerm script for mandos
 #
 # see: dh_installdeb(1)

=== removed file 'debian/source/local-options'
--- debian/source/local-options	2011-10-08 21:13:46 +0000
+++ debian/source/local-options	1970-01-01 00:00:00 +0000
@@ -1,1 +0,0 @@
---single-debian-patch

=== modified file 'debian/watch'
--- debian/watch	2011-10-05 16:00:56 +0000
+++ debian/watch	2010-09-15 17:17:46 +0000
@@ -1,2 +1,2 @@
 version=3
-ftp://ftp.recompile.se/pub/mandos/mandos[-_]([^\s]+?)(?:\.orig)?\.tar\.(?:gz|bz2|7z|xz)
+ftp://ftp.fukt.bsnet.se/pub/mandos/mandos[-_]([^\s]+?)(?:\.orig)?\.tar\.(?:gz|bz2|7z|xz)

=== modified file 'init.d-mandos'
--- init.d-mandos	2011-10-05 16:00:56 +0000
+++ init.d-mandos	2009-09-16 23:28:39 +0000
@@ -9,8 +9,8 @@
 # Description:       Gives encrypted passwords to Mandos clients
 ### END INIT INFO
 
-# Author: Teddy Hogeborn <teddy@recompile.se>
-# Author: Björn Påhlsson <belorn@recompile.se>
+# Author: Teddy Hogeborn <teddy@fukt.bsnet.se>
+# Author: Björn Påhlsson <belorn@fukt.bsnet.se>
 #
 # Please remove the "Author" lines above and replace them
 # with your own name if you copy and modify this script.

=== modified file 'initramfs-tools-hook'
--- initramfs-tools-hook	2011-10-05 16:56:06 +0000
+++ initramfs-tools-hook	2010-09-09 18:16:14 +0000
@@ -131,7 +131,7 @@
 	"${DESTDIR}${CONFDIR}/plugin-runner.conf"
 fi
 
-# Key files
+# Key files 
 for file in "$keydir"/*; do
     if [ -d "$file" ]; then
 	continue

=== modified file 'intro.xml'
--- intro.xml	2011-10-05 16:00:56 +0000
+++ intro.xml	2011-08-08 21:12:37 +0000
@@ -1,7 +1,7 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 "http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
-<!ENTITY TIMESTAMP "2011-10-03">
+<!ENTITY TIMESTAMP "2011-08-08">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -18,14 +18,14 @@
 	<firstname>Björn</firstname>
 	<surname>Påhlsson</surname>
 	<address>
-	  <email>belorn@recompile.se</email>
+	  <email>belorn@fukt.bsnet.se</email>
 	</address>
       </author>
       <author>
 	<firstname>Teddy</firstname>
 	<surname>Hogeborn</surname>
 	<address>
-	  <email>teddy@recompile.se</email>
+	  <email>teddy@fukt.bsnet.se</email>
 	</address>
       </author>
     </authorgroup>
@@ -392,7 +392,7 @@
     <variablelist>
       <varlistentry>
 	<term>
-	  <ulink url="http://www.recompile.se/mandos">Mandos</ulink>
+	  <ulink url="http://www.fukt.bsnet.se/mandos">Mandos</ulink>
 	</term>
 	<listitem>
 	  <para>

=== modified file 'mandos'
--- mandos	2011-11-27 19:51:00 +0000
+++ mandos	2011-07-27 17:58:27 +0000
@@ -28,7 +28,7 @@
 # along with this program.  If not, see
 # <http://www.gnu.org/licenses/>.
 # 
-# Contact the authors at <mandos@recompile.se>.
+# Contact the authors at <mandos@fukt.bsnet.se>.
 # 
 
 from __future__ import (division, absolute_import, print_function,
@@ -62,9 +62,6 @@
 import functools
 import cPickle as pickle
 import multiprocessing
-import types
-import binascii
-import tempfile
 
 import dbus
 import dbus.service
@@ -75,7 +72,6 @@
 import ctypes.util
 import xml.dom.minidom
 import inspect
-import GnuPGInterface
 
 try:
     SO_BINDTODEVICE = socket.SO_BINDTODEVICE
@@ -86,127 +82,23 @@
         SO_BINDTODEVICE = None
 
 
-version = "1.4.1"
-stored_state_file = "clients.pickle"
+version = "1.3.1"
 
-logger = logging.getLogger()
+#logger = logging.getLogger('mandos')
+logger = logging.Logger('mandos')
 syslogger = (logging.handlers.SysLogHandler
              (facility = logging.handlers.SysLogHandler.LOG_DAEMON,
               address = str("/dev/log")))
-
-try:
-    if_nametoindex = (ctypes.cdll.LoadLibrary
-                      (ctypes.util.find_library("c"))
-                      .if_nametoindex)
-except (OSError, AttributeError):
-    def if_nametoindex(interface):
-        "Get an interface index the hard way, i.e. using fcntl()"
-        SIOCGIFINDEX = 0x8933  # From /usr/include/linux/sockios.h
-        with contextlib.closing(socket.socket()) as s:
-            ifreq = fcntl.ioctl(s, SIOCGIFINDEX,
-                                struct.pack(str("16s16x"),
-                                            interface))
-        interface_index = struct.unpack(str("I"),
-                                        ifreq[16:20])[0]
-        return interface_index
-
-
-def initlogger(level=logging.WARNING):
-    """init logger and add loglevel"""
-    
-    syslogger.setFormatter(logging.Formatter
-                           ('Mandos [%(process)d]: %(levelname)s:'
-                            ' %(message)s'))
-    logger.addHandler(syslogger)
-    
-    console = logging.StreamHandler()
-    console.setFormatter(logging.Formatter('%(asctime)s %(name)s'
-                                           ' [%(process)d]:'
-                                           ' %(levelname)s:'
-                                           ' %(message)s'))
-    logger.addHandler(console)
-    logger.setLevel(level)
-
-
-class PGPError(Exception):
-    """Exception if encryption/decryption fails"""
-    pass
-
-
-class PGPEngine(object):
-    """A simple class for OpenPGP symmetric encryption & decryption"""
-    def __init__(self):
-        self.gnupg = GnuPGInterface.GnuPG()
-        self.tempdir = tempfile.mkdtemp(prefix="mandos-")
-        self.gnupg = GnuPGInterface.GnuPG()
-        self.gnupg.options.meta_interactive = False
-        self.gnupg.options.homedir = self.tempdir
-        self.gnupg.options.extra_args.extend(['--force-mdc',
-                                              '--quiet'])
-    
-    def __enter__(self):
-        return self
-    
-    def __exit__ (self, exc_type, exc_value, traceback):
-        self._cleanup()
-        return False
-    
-    def __del__(self):
-        self._cleanup()
-    
-    def _cleanup(self):
-        if self.tempdir is not None:
-            # Delete contents of tempdir
-            for root, dirs, files in os.walk(self.tempdir,
-                                             topdown = False):
-                for filename in files:
-                    os.remove(os.path.join(root, filename))
-                for dirname in dirs:
-                    os.rmdir(os.path.join(root, dirname))
-            # Remove tempdir
-            os.rmdir(self.tempdir)
-            self.tempdir = None
-    
-    def password_encode(self, password):
-        # Passphrase can not be empty and can not contain newlines or
-        # NUL bytes.  So we prefix it and hex encode it.
-        return b"mandos" + binascii.hexlify(password)
-    
-    def encrypt(self, data, password):
-        self.gnupg.passphrase = self.password_encode(password)
-        with open(os.devnull) as devnull:
-            try:
-                proc = self.gnupg.run(['--symmetric'],
-                                      create_fhs=['stdin', 'stdout'],
-                                      attach_fhs={'stderr': devnull})
-                with contextlib.closing(proc.handles['stdin']) as f:
-                    f.write(data)
-                with contextlib.closing(proc.handles['stdout']) as f:
-                    ciphertext = f.read()
-                proc.wait()
-            except IOError as e:
-                raise PGPError(e)
-        self.gnupg.passphrase = None
-        return ciphertext
-    
-    def decrypt(self, data, password):
-        self.gnupg.passphrase = self.password_encode(password)
-        with open(os.devnull) as devnull:
-            try:
-                proc = self.gnupg.run(['--decrypt'],
-                                      create_fhs=['stdin', 'stdout'],
-                                      attach_fhs={'stderr': devnull})
-                with contextlib.closing(proc.handles['stdin'] ) as f:
-                    f.write(data)
-                with contextlib.closing(proc.handles['stdout']) as f:
-                    decrypted_plaintext = f.read()
-                proc.wait()
-            except IOError as e:
-                raise PGPError(e)
-        self.gnupg.passphrase = None
-        return decrypted_plaintext
-
-
+syslogger.setFormatter(logging.Formatter
+                       ('Mandos [%(process)d]: %(levelname)s:'
+                        ' %(message)s'))
+logger.addHandler(syslogger)
+
+console = logging.StreamHandler()
+console.setFormatter(logging.Formatter('%(name)s [%(process)d]:'
+                                       ' %(levelname)s:'
+                                       ' %(message)s'))
+logger.addHandler(console)
 
 class AvahiError(Exception):
     def __init__(self, value, *args, **kwargs):
@@ -267,10 +159,13 @@
                             " after %i retries, exiting.",
                             self.rename_count)
             raise AvahiServiceError("Too many renames")
-        self.name = unicode(self.server
-                            .GetAlternativeServiceName(self.name))
+        self.name = unicode(self.server.GetAlternativeServiceName(self.name))
         logger.info("Changing Zeroconf service name to %r ...",
                     self.name)
+        syslogger.setFormatter(logging.Formatter
+                               ('Mandos (%s) [%%(process)d]:'
+                                ' %%(levelname)s: %%(message)s'
+                                % self.name))
         self.remove()
         try:
             self.add()
@@ -296,7 +191,7 @@
                 avahi.DBUS_INTERFACE_ENTRY_GROUP)
         self.entry_group_state_changed_match = (
             self.group.connect_to_signal(
-                'StateChanged', self.entry_group_state_changed))
+                'StateChanged', self .entry_group_state_changed))
         logger.debug("Adding Zeroconf service '%s' of type '%s' ...",
                      self.name, self.type)
         self.group.AddService(
@@ -328,7 +223,7 @@
             try:
                 self.group.Free()
             except (dbus.exceptions.UnknownMethodException,
-                    dbus.exceptions.DBusException):
+                    dbus.exceptions.DBusException) as e:
                 pass
             self.group = None
         self.remove()
@@ -368,22 +263,7 @@
                                  self.server_state_changed)
         self.server_state_changed(self.server.GetState())
 
-class AvahiServiceToSyslog(AvahiService):
-    def rename(self):
-        """Add the new name to the syslog messages"""
-        ret = AvahiService.rename(self)
-        syslogger.setFormatter(logging.Formatter
-                               ('Mandos (%s) [%%(process)d]:'
-                                ' %%(levelname)s: %%(message)s'
-                                % self.name))
-        return ret
 
-def _timedelta_to_milliseconds(td):
-    "Convert a datetime.timedelta() to milliseconds"
-    return ((td.days * 24 * 60 * 60 * 1000)
-            + (td.seconds * 1000)
-            + (td.microseconds // 1000))
-        
 class Client(object):
     """A representation of a client host served by this server.
     
@@ -401,9 +281,8 @@
                      instance %(name)s can be used in the command.
     checker_initiator_tag: a gobject event source tag, or None
     created:    datetime.datetime(); (UTC) object creation
-    client_structure: Object describing what attributes a client has
-                      and is used for storing the client at exit
     current_checker_command: string; current running checker_command
+    disable_hook:  If set, called by disable() as disable_hook(self)
     disable_initiator_tag: a gobject event source tag, or None
     enabled:    bool()
     fingerprint: string (40 or 32 hexadecimal digits); used to
@@ -412,20 +291,13 @@
     interval:   datetime.timedelta(); How often to start a new checker
     last_approval_request: datetime.datetime(); (UTC) or None
     last_checked_ok: datetime.datetime(); (UTC) or None
-
-    last_checker_status: integer between 0 and 255 reflecting exit
-                         status of last checker. -1 reflects crashed
-                         checker, or None.
-    last_enabled: datetime.datetime(); (UTC) or None
+    last_enabled: datetime.datetime(); (UTC)
     name:       string; from the config file, used in log messages and
                         D-Bus identifiers
     secret:     bytestring; sent verbatim (over TLS) to client
     timeout:    datetime.timedelta(); How long from last_checked_ok
                                       until this client is disabled
-    extended_timeout:   extra long timeout when password has been sent
     runtime_expansions: Allowed attributes for runtime expansion.
-    expires:    datetime.datetime(); time (UTC) when a client will be
-                disabled, or None
     """
     
     runtime_expansions = ("approval_delay", "approval_duration",
@@ -433,22 +305,25 @@
                           "host", "interval", "last_checked_ok",
                           "last_enabled", "name", "timeout")
     
+    @staticmethod
+    def _timedelta_to_milliseconds(td):
+        "Convert a datetime.timedelta() to milliseconds"
+        return ((td.days * 24 * 60 * 60 * 1000)
+                + (td.seconds * 1000)
+                + (td.microseconds // 1000))
+    
     def timeout_milliseconds(self):
         "Return the 'timeout' attribute in milliseconds"
-        return _timedelta_to_milliseconds(self.timeout)
-    
-    def extended_timeout_milliseconds(self):
-        "Return the 'extended_timeout' attribute in milliseconds"
-        return _timedelta_to_milliseconds(self.extended_timeout)
+        return self._timedelta_to_milliseconds(self.timeout)
     
     def interval_milliseconds(self):
         "Return the 'interval' attribute in milliseconds"
-        return _timedelta_to_milliseconds(self.interval)
-    
+        return self._timedelta_to_milliseconds(self.interval)
+
     def approval_delay_milliseconds(self):
-        return _timedelta_to_milliseconds(self.approval_delay)
+        return self._timedelta_to_milliseconds(self.approval_delay)
     
-    def __init__(self, name = None, config=None):
+    def __init__(self, name = None, disable_hook=None, config=None):
         """Note: the 'checker' key in 'config' sets the
         'checker_command' attribute and *not* the 'checker'
         attribute."""
@@ -474,28 +349,20 @@
                             % self.name)
         self.host = config.get("host", "")
         self.created = datetime.datetime.utcnow()
-        self.enabled = config.get("enabled", True)
+        self.enabled = False
         self.last_approval_request = None
-        if self.enabled:
-            self.last_enabled = datetime.datetime.utcnow()
-        else:
-            self.last_enabled = None
+        self.last_enabled = None
         self.last_checked_ok = None
-        self.last_checker_status = None
         self.timeout = string_to_delta(config["timeout"])
-        self.extended_timeout = string_to_delta(config
-                                                ["extended_timeout"])
         self.interval = string_to_delta(config["interval"])
+        self.disable_hook = disable_hook
         self.checker = None
         self.checker_initiator_tag = None
         self.disable_initiator_tag = None
-        if self.enabled:
-            self.expires = datetime.datetime.utcnow() + self.timeout
-        else:
-            self.expires = None
         self.checker_callback_tag = None
         self.checker_command = config["checker"]
         self.current_checker_command = None
+        self.last_connect = None
         self._approved = None
         self.approved_by_default = config.get("approved_by_default",
                                               True)
@@ -504,36 +371,32 @@
             config["approval_delay"])
         self.approval_duration = string_to_delta(
             config["approval_duration"])
-        self.changedstate = (multiprocessing_manager
-                             .Condition(multiprocessing_manager
-                                        .Lock()))
-        self.client_structure = [attr for attr in
-                                 self.__dict__.iterkeys()
-                                 if not attr.startswith("_")]
-        self.client_structure.append("client_structure")
-        
-        for name, t in inspect.getmembers(type(self),
-                                          lambda obj:
-                                              isinstance(obj,
-                                                         property)):
-            if not name.startswith("_"):
-                self.client_structure.append(name)
+        self.changedstate = multiprocessing_manager.Condition(multiprocessing_manager.Lock())
     
-    # Send notice to process children that client state has changed
     def send_changedstate(self):
-        with self.changedstate:
-            self.changedstate.notify_all()
-    
+        self.changedstate.acquire()
+        self.changedstate.notify_all()
+        self.changedstate.release()
+        
     def enable(self):
         """Start this client's checker and timeout hooks"""
         if getattr(self, "enabled", False):
             # Already enabled
             return
         self.send_changedstate()
-        self.expires = datetime.datetime.utcnow() + self.timeout
-        self.enabled = True
         self.last_enabled = datetime.datetime.utcnow()
-        self.init_checker()
+        # Schedule a new checker to be started an 'interval' from now,
+        # and every interval from then on.
+        self.checker_initiator_tag = (gobject.timeout_add
+                                      (self.interval_milliseconds(),
+                                       self.start_checker))
+        # Schedule a disable() when 'timeout' has passed
+        self.disable_initiator_tag = (gobject.timeout_add
+                                   (self.timeout_milliseconds(),
+                                    self.disable))
+        self.enabled = True
+        # Also start a new checker *right now*.
+        self.start_checker()
     
     def disable(self, quiet=True):
         """Disable this client."""
@@ -546,38 +409,27 @@
         if getattr(self, "disable_initiator_tag", False):
             gobject.source_remove(self.disable_initiator_tag)
             self.disable_initiator_tag = None
-        self.expires = None
         if getattr(self, "checker_initiator_tag", False):
             gobject.source_remove(self.checker_initiator_tag)
             self.checker_initiator_tag = None
         self.stop_checker()
+        if self.disable_hook:
+            self.disable_hook(self)
         self.enabled = False
         # Do not run this again if called by a gobject.timeout_add
         return False
     
     def __del__(self):
+        self.disable_hook = None
         self.disable()
     
-    def init_checker(self):
-        # Schedule a new checker to be started an 'interval' from now,
-        # and every interval from then on.
-        self.checker_initiator_tag = (gobject.timeout_add
-                                      (self.interval_milliseconds(),
-                                       self.start_checker))
-        # Schedule a disable() when 'timeout' has passed
-        self.disable_initiator_tag = (gobject.timeout_add
-                                   (self.timeout_milliseconds(),
-                                    self.disable))
-        # Also start a new checker *right now*.
-        self.start_checker()
-    
     def checker_callback(self, pid, condition, command):
         """The checker has completed, so take appropriate actions."""
         self.checker_callback_tag = None
         self.checker = None
         if os.WIFEXITED(condition):
-            self.last_checker_status =  os.WEXITSTATUS(condition)
-            if self.last_checker_status == 0:
+            exitstatus = os.WEXITSTATUS(condition)
+            if exitstatus == 0:
                 logger.info("Checker for %(name)s succeeded",
                             vars(self))
                 self.checked_ok()
@@ -585,26 +437,20 @@
                 logger.info("Checker for %(name)s failed",
                             vars(self))
         else:
-            self.last_checker_status = -1
             logger.warning("Checker for %(name)s crashed?",
                            vars(self))
     
-    def checked_ok(self, timeout=None):
+    def checked_ok(self):
         """Bump up the timeout for this client.
         
         This should only be called when the client has been seen,
         alive and well.
         """
-        if timeout is None:
-            timeout = self.timeout
         self.last_checked_ok = datetime.datetime.utcnow()
-        if self.disable_initiator_tag is not None:
-            gobject.source_remove(self.disable_initiator_tag)
-        if getattr(self, "enabled", False):
-            self.disable_initiator_tag = (gobject.timeout_add
-                                          (_timedelta_to_milliseconds
-                                           (timeout), self.disable))
-            self.expires = datetime.datetime.utcnow() + timeout
+        gobject.source_remove(self.disable_initiator_tag)
+        self.disable_initiator_tag = (gobject.timeout_add
+                                      (self.timeout_milliseconds(),
+                                       self.disable))
     
     def need_approval(self):
         self.last_approval_request = datetime.datetime.utcnow()
@@ -650,7 +496,7 @@
                                        'replace')))
                     for attr in
                     self.runtime_expansions)
-                
+
                 try:
                     command = self.checker_command % escaped_attrs
                 except TypeError as error:
@@ -702,7 +548,6 @@
                 raise
         self.checker = None
 
-
 def dbus_service_property(dbus_interface, signature="v",
                           access="readwrite", byte_arrays=False):
     """Decorators for marking methods of a DBusObjectWithProperties to
@@ -754,7 +599,7 @@
 
 class DBusObjectWithProperties(dbus.service.Object):
     """A D-Bus object with properties.
-    
+
     Classes inheriting from this can use the dbus_service_property
     decorator to expose methods as D-Bus properties.  It exposes the
     standard Get(), Set(), and GetAll() methods on the D-Bus.
@@ -767,22 +612,24 @@
     def _get_all_dbus_properties(self):
         """Returns a generator of (name, attribute) pairs
         """
-        return ((prop.__get__(self)._dbus_name, prop.__get__(self))
-                for cls in self.__class__.__mro__
+        return ((prop._dbus_name, prop)
                 for name, prop in
-                inspect.getmembers(cls, self._is_dbus_property))
+                inspect.getmembers(self, self._is_dbus_property))
     
     def _get_dbus_property(self, interface_name, property_name):
         """Returns a bound method if one exists which is a D-Bus
         property with the specified name and interface.
         """
-        for cls in  self.__class__.__mro__:
-            for name, value in (inspect.getmembers
-                                (cls, self._is_dbus_property)):
-                if (value._dbus_name == property_name
-                    and value._dbus_interface == interface_name):
-                    return value.__get__(self)
-        
+        for name in (property_name,
+                     property_name + "_dbus_property"):
+            prop = getattr(self, name, None)
+            if (prop is None
+                or not self._is_dbus_property(prop)
+                or prop._dbus_name != property_name
+                or (interface_name and prop._dbus_interface
+                    and interface_name != prop._dbus_interface)):
+                continue
+            return prop
         # No such property
         raise DBusPropertyNotFound(self.dbus_object_path + ":"
                                    + interface_name + "."
@@ -822,10 +669,10 @@
     def GetAll(self, interface_name):
         """Standard D-Bus property GetAll() method, see D-Bus
         standard.
-        
+
         Note: Will not include properties with access="write".
         """
-        properties = {}
+        all = {}
         for name, prop in self._get_all_dbus_properties():
             if (interface_name
                 and interface_name != prop._dbus_interface):
@@ -836,11 +683,11 @@
                 continue
             value = prop()
             if not hasattr(value, "variant_level"):
-                properties[name] = value
+                all[name] = value
                 continue
-            properties[name] = type(value)(value, variant_level=
-                                           value.variant_level+1)
-        return dbus.Dictionary(properties, signature="sv")
+            all[name] = type(value)(value, variant_level=
+                                    value.variant_level+1)
+        return dbus.Dictionary(all, signature="sv")
     
     @dbus.service.method(dbus.INTROSPECTABLE_IFACE,
                          out_signature="s",
@@ -890,112 +737,6 @@
         return xmlstring
 
 
-def datetime_to_dbus (dt, variant_level=0):
-    """Convert a UTC datetime.datetime() to a D-Bus type."""
-    if dt is None:
-        return dbus.String("", variant_level = variant_level)
-    return dbus.String(dt.isoformat(),
-                       variant_level=variant_level)
-
-
-class AlternateDBusNamesMetaclass(DBusObjectWithProperties
-                                  .__metaclass__):
-    """Applied to an empty subclass of a D-Bus object, this metaclass
-    will add additional D-Bus attributes matching a certain pattern.
-    """
-    def __new__(mcs, name, bases, attr):
-        # Go through all the base classes which could have D-Bus
-        # methods, signals, or properties in them
-        for base in (b for b in bases
-                     if issubclass(b, dbus.service.Object)):
-            # Go though all attributes of the base class
-            for attrname, attribute in inspect.getmembers(base):
-                # Ignore non-D-Bus attributes, and D-Bus attributes
-                # with the wrong interface name
-                if (not hasattr(attribute, "_dbus_interface")
-                    or not attribute._dbus_interface
-                    .startswith("se.recompile.Mandos")):
-                    continue
-                # Create an alternate D-Bus interface name based on
-                # the current name
-                alt_interface = (attribute._dbus_interface
-                                 .replace("se.recompile.Mandos",
-                                          "se.bsnet.fukt.Mandos"))
-                # Is this a D-Bus signal?
-                if getattr(attribute, "_dbus_is_signal", False):
-                    # Extract the original non-method function by
-                    # black magic
-                    nonmethod_func = (dict(
-                            zip(attribute.func_code.co_freevars,
-                                attribute.__closure__))["func"]
-                                      .cell_contents)
-                    # Create a new, but exactly alike, function
-                    # object, and decorate it to be a new D-Bus signal
-                    # with the alternate D-Bus interface name
-                    new_function = (dbus.service.signal
-                                    (alt_interface,
-                                     attribute._dbus_signature)
-                                    (types.FunctionType(
-                                nonmethod_func.func_code,
-                                nonmethod_func.func_globals,
-                                nonmethod_func.func_name,
-                                nonmethod_func.func_defaults,
-                                nonmethod_func.func_closure)))
-                    # Define a creator of a function to call both the
-                    # old and new functions, so both the old and new
-                    # signals gets sent when the function is called
-                    def fixscope(func1, func2):
-                        """This function is a scope container to pass
-                        func1 and func2 to the "call_both" function
-                        outside of its arguments"""
-                        def call_both(*args, **kwargs):
-                            """This function will emit two D-Bus
-                            signals by calling func1 and func2"""
-                            func1(*args, **kwargs)
-                            func2(*args, **kwargs)
-                        return call_both
-                    # Create the "call_both" function and add it to
-                    # the class
-                    attr[attrname] = fixscope(attribute,
-                                              new_function)
-                # Is this a D-Bus method?
-                elif getattr(attribute, "_dbus_is_method", False):
-                    # Create a new, but exactly alike, function
-                    # object.  Decorate it to be a new D-Bus method
-                    # with the alternate D-Bus interface name.  Add it
-                    # to the class.
-                    attr[attrname] = (dbus.service.method
-                                      (alt_interface,
-                                       attribute._dbus_in_signature,
-                                       attribute._dbus_out_signature)
-                                      (types.FunctionType
-                                       (attribute.func_code,
-                                        attribute.func_globals,
-                                        attribute.func_name,
-                                        attribute.func_defaults,
-                                        attribute.func_closure)))
-                # Is this a D-Bus property?
-                elif getattr(attribute, "_dbus_is_property", False):
-                    # Create a new, but exactly alike, function
-                    # object, and decorate it to be a new D-Bus
-                    # property with the alternate D-Bus interface
-                    # name.  Add it to the class.
-                    attr[attrname] = (dbus_service_property
-                                      (alt_interface,
-                                       attribute._dbus_signature,
-                                       attribute._dbus_access,
-                                       attribute
-                                       ._dbus_get_args_options
-                                       ["byte_arrays"])
-                                      (types.FunctionType
-                                       (attribute.func_code,
-                                        attribute.func_globals,
-                                        attribute.func_name,
-                                        attribute.func_defaults,
-                                        attribute.func_closure)))
-        return type.__new__(mcs, name, bases, attr)
-
-
 class ClientDBus(Client, DBusObjectWithProperties):
     """A Client class using D-Bus
     
@@ -1010,10 +751,9 @@
     # dbus.service.Object doesn't use super(), so we can't either.
     
     def __init__(self, bus = None, *args, **kwargs):
+        self._approvals_pending = 0
         self.bus = bus
         Client.__init__(self, *args, **kwargs)
-        
-        self._approvals_pending = 0
         # Only now, when this client is initialized, can it show up on
         # the D-Bus
         client_object_name = unicode(self.name).translate(
@@ -1024,72 +764,49 @@
         DBusObjectWithProperties.__init__(self, self.bus,
                                           self.dbus_object_path)
         
-    def notifychangeproperty(transform_func,
-                             dbus_name, type_func=lambda x: x,
-                             variant_level=1):
-        """ Modify a variable so that it's a property which announces
-        its changes to DBus.
-        
-        transform_fun: Function that takes a value and a variant_level
-                       and transforms it to a D-Bus type.
-        dbus_name: D-Bus name of the variable
-        type_func: Function that transform the value before sending it
-                   to the D-Bus.  Default: no transform
-        variant_level: D-Bus variant level.  Default: 1
-        """
-        attrname = "_{0}".format(dbus_name)
-        def setter(self, value):
-            if hasattr(self, "dbus_object_path"):
-                if (not hasattr(self, attrname) or
-                    type_func(getattr(self, attrname, None))
-                    != type_func(value)):
-                    dbus_value = transform_func(type_func(value),
-                                                variant_level
-                                                =variant_level)
-                    self.PropertyChanged(dbus.String(dbus_name),
-                                         dbus_value)
-            setattr(self, attrname, value)
-        
-        return property(lambda self: getattr(self, attrname), setter)
-    
-    
-    expires = notifychangeproperty(datetime_to_dbus, "Expires")
-    approvals_pending = notifychangeproperty(dbus.Boolean,
-                                             "ApprovalPending",
-                                             type_func = bool)
-    enabled = notifychangeproperty(dbus.Boolean, "Enabled")
-    last_enabled = notifychangeproperty(datetime_to_dbus,
-                                        "LastEnabled")
-    checker = notifychangeproperty(dbus.Boolean, "CheckerRunning",
-                                   type_func = lambda checker:
-                                       checker is not None)
-    last_checked_ok = notifychangeproperty(datetime_to_dbus,
-                                           "LastCheckedOK")
-    last_approval_request = notifychangeproperty(
-        datetime_to_dbus, "LastApprovalRequest")
-    approved_by_default = notifychangeproperty(dbus.Boolean,
-                                               "ApprovedByDefault")
-    approval_delay = notifychangeproperty(dbus.UInt16,
-                                          "ApprovalDelay",
-                                          type_func =
-                                          _timedelta_to_milliseconds)
-    approval_duration = notifychangeproperty(
-        dbus.UInt16, "ApprovalDuration",
-        type_func = _timedelta_to_milliseconds)
-    host = notifychangeproperty(dbus.String, "Host")
-    timeout = notifychangeproperty(dbus.UInt16, "Timeout",
-                                   type_func =
-                                   _timedelta_to_milliseconds)
-    extended_timeout = notifychangeproperty(
-        dbus.UInt16, "ExtendedTimeout",
-        type_func = _timedelta_to_milliseconds)
-    interval = notifychangeproperty(dbus.UInt16,
-                                    "Interval",
-                                    type_func =
-                                    _timedelta_to_milliseconds)
-    checker_command = notifychangeproperty(dbus.String, "Checker")
-    
-    del notifychangeproperty
+    def _get_approvals_pending(self):
+        return self._approvals_pending
+    def _set_approvals_pending(self, value):
+        old_value = self._approvals_pending
+        self._approvals_pending = value
+        bval = bool(value)
+        if (hasattr(self, "dbus_object_path")
+            and bval is not bool(old_value)):
+            dbus_bool = dbus.Boolean(bval, variant_level=1)
+            self.PropertyChanged(dbus.String("ApprovalPending"),
+                                 dbus_bool)
+
+    approvals_pending = property(_get_approvals_pending,
+                                 _set_approvals_pending)
+    del _get_approvals_pending, _set_approvals_pending
+    
+    @staticmethod
+    def _datetime_to_dbus(dt, variant_level=0):
+        """Convert a UTC datetime.datetime() to a D-Bus type."""
+        return dbus.String(dt.isoformat(),
+                           variant_level=variant_level)
+    
+    def enable(self):
+        oldstate = getattr(self, "enabled", False)
+        r = Client.enable(self)
+        if oldstate != self.enabled:
+            # Emit D-Bus signals
+            self.PropertyChanged(dbus.String("Enabled"),
+                                 dbus.Boolean(True, variant_level=1))
+            self.PropertyChanged(
+                dbus.String("LastEnabled"),
+                self._datetime_to_dbus(self.last_enabled,
+                                       variant_level=1))
+        return r
+    
+    def disable(self, quiet = False):
+        oldstate = getattr(self, "enabled", False)
+        r = Client.disable(self, quiet=quiet)
+        if not quiet and oldstate != self.enabled:
+            # Emit D-Bus signal
+            self.PropertyChanged(dbus.String("Enabled"),
+                                 dbus.Boolean(False, variant_level=1))
+        return r
     
     def __del__(self, *args, **kwargs):
         try:
@@ -1104,6 +821,9 @@
                          *args, **kwargs):
         self.checker_callback_tag = None
         self.checker = None
+        # Emit D-Bus signal
+        self.PropertyChanged(dbus.String("CheckerRunning"),
+                             dbus.Boolean(False, variant_level=1))
         if os.WIFEXITED(condition):
             exitstatus = os.WEXITSTATUS(condition)
             # Emit D-Bus signal
@@ -1119,6 +839,23 @@
         return Client.checker_callback(self, pid, condition, command,
                                        *args, **kwargs)
     
+    def checked_ok(self, *args, **kwargs):
+        Client.checked_ok(self, *args, **kwargs)
+        # Emit D-Bus signal
+        self.PropertyChanged(
+            dbus.String("LastCheckedOK"),
+            (self._datetime_to_dbus(self.last_checked_ok,
+                                    variant_level=1)))
+    
+    def need_approval(self, *args, **kwargs):
+        r = Client.need_approval(self, *args, **kwargs)
+        # Emit D-Bus signal
+        self.PropertyChanged(
+            dbus.String("LastApprovalRequest"),
+            (self._datetime_to_dbus(self.last_approval_request,
+                                    variant_level=1)))
+        return r
+    
     def start_checker(self, *args, **kwargs):
         old_checker = self.checker
         if self.checker is not None:
@@ -1131,8 +868,20 @@
             and old_checker_pid != self.checker.pid):
             # Emit D-Bus signal
             self.CheckerStarted(self.current_checker_command)
+            self.PropertyChanged(
+                dbus.String("CheckerRunning"),
+                dbus.Boolean(True, variant_level=1))
         return r
     
+    def stop_checker(self, *args, **kwargs):
+        old_checker = getattr(self, "checker", None)
+        r = Client.stop_checker(self, *args, **kwargs)
+        if (old_checker is not None
+            and getattr(self, "checker", None) is None):
+            self.PropertyChanged(dbus.String("CheckerRunning"),
+                                 dbus.Boolean(False, variant_level=1))
+        return r
+
     def _reset_approved(self):
         self._approved = None
         return False
@@ -1140,13 +889,13 @@
     def approve(self, value=True):
         self.send_changedstate()
         self._approved = value
-        gobject.timeout_add(_timedelta_to_milliseconds
+        gobject.timeout_add(self._timedelta_to_milliseconds
                             (self.approval_duration),
                             self._reset_approved)
     
     
     ## D-Bus methods, signals & properties
-    _interface = "se.recompile.Mandos.Client"
+    _interface = "se.bsnet.fukt.Mandos.Client"
     
     ## Signals
     
@@ -1189,14 +938,6 @@
         "D-Bus signal"
         return self.need_approval()
     
-    # NeRwequest - signal
-    @dbus.service.signal(_interface, signature="s")
-    def NewRequest(self, ip):
-        """D-Bus signal
-        Is sent after a client request a password.
-        """
-        pass
-    
     ## Methods
     
     # Approve - method
@@ -1246,6 +987,9 @@
         if value is None:       # get
             return dbus.Boolean(self.approved_by_default)
         self.approved_by_default = bool(value)
+        # Emit D-Bus signal
+        self.PropertyChanged(dbus.String("ApprovedByDefault"),
+                             dbus.Boolean(value, variant_level=1))
     
     # ApprovalDelay - property
     @dbus_service_property(_interface, signature="t",
@@ -1254,15 +998,21 @@
         if value is None:       # get
             return dbus.UInt64(self.approval_delay_milliseconds())
         self.approval_delay = datetime.timedelta(0, 0, 0, value)
+        # Emit D-Bus signal
+        self.PropertyChanged(dbus.String("ApprovalDelay"),
+                             dbus.UInt64(value, variant_level=1))
     
     # ApprovalDuration - property
     @dbus_service_property(_interface, signature="t",
                            access="readwrite")
     def ApprovalDuration_dbus_property(self, value=None):
         if value is None:       # get
-            return dbus.UInt64(_timedelta_to_milliseconds(
+            return dbus.UInt64(self._timedelta_to_milliseconds(
                     self.approval_duration))
         self.approval_duration = datetime.timedelta(0, 0, 0, value)
+        # Emit D-Bus signal
+        self.PropertyChanged(dbus.String("ApprovalDuration"),
+                             dbus.UInt64(value, variant_level=1))
     
     # Name - property
     @dbus_service_property(_interface, signature="s", access="read")
@@ -1281,16 +1031,21 @@
         if value is None:       # get
             return dbus.String(self.host)
         self.host = value
+        # Emit D-Bus signal
+        self.PropertyChanged(dbus.String("Host"),
+                             dbus.String(value, variant_level=1))
     
     # Created - property
     @dbus_service_property(_interface, signature="s", access="read")
     def Created_dbus_property(self):
-        return datetime_to_dbus(self.created)
+        return dbus.String(self._datetime_to_dbus(self.created))
     
     # LastEnabled - property
     @dbus_service_property(_interface, signature="s", access="read")
     def LastEnabled_dbus_property(self):
-        return datetime_to_dbus(self.last_enabled)
+        if self.last_enabled is None:
+            return dbus.String("")
+        return dbus.String(self._datetime_to_dbus(self.last_enabled))
     
     # Enabled - property
     @dbus_service_property(_interface, signature="b",
@@ -1310,17 +1065,19 @@
         if value is not None:
             self.checked_ok()
             return
-        return datetime_to_dbus(self.last_checked_ok)
-    
-    # Expires - property
-    @dbus_service_property(_interface, signature="s", access="read")
-    def Expires_dbus_property(self):
-        return datetime_to_dbus(self.expires)
+        if self.last_checked_ok is None:
+            return dbus.String("")
+        return dbus.String(self._datetime_to_dbus(self
+                                                  .last_checked_ok))
     
     # LastApprovalRequest - property
     @dbus_service_property(_interface, signature="s", access="read")
     def LastApprovalRequest_dbus_property(self):
-        return datetime_to_dbus(self.last_approval_request)
+        if self.last_approval_request is None:
+            return dbus.String("")
+        return dbus.String(self.
+                           _datetime_to_dbus(self
+                                             .last_approval_request))
     
     # Timeout - property
     @dbus_service_property(_interface, signature="t",
@@ -1329,35 +1086,27 @@
         if value is None:       # get
             return dbus.UInt64(self.timeout_milliseconds())
         self.timeout = datetime.timedelta(0, 0, 0, value)
+        # Emit D-Bus signal
+        self.PropertyChanged(dbus.String("Timeout"),
+                             dbus.UInt64(value, variant_level=1))
         if getattr(self, "disable_initiator_tag", None) is None:
             return
         # Reschedule timeout
         gobject.source_remove(self.disable_initiator_tag)
         self.disable_initiator_tag = None
-        self.expires = None
-        time_to_die = _timedelta_to_milliseconds((self
-                                                  .last_checked_ok
-                                                  + self.timeout)
-                                                 - datetime.datetime
-                                                 .utcnow())
+        time_to_die = (self.
+                       _timedelta_to_milliseconds((self
+                                                   .last_checked_ok
+                                                   + self.timeout)
+                                                  - datetime.datetime
+                                                  .utcnow()))
         if time_to_die <= 0:
             # The timeout has passed
             self.disable()
         else:
-            self.expires = (datetime.datetime.utcnow()
-                            + datetime.timedelta(milliseconds =
-                                                 time_to_die))
             self.disable_initiator_tag = (gobject.timeout_add
                                           (time_to_die, self.disable))
     
-    # ExtendedTimeout - property
-    @dbus_service_property(_interface, signature="t",
-                           access="readwrite")
-    def ExtendedTimeout_dbus_property(self, value=None):
-        if value is None:       # get
-            return dbus.UInt64(self.extended_timeout_milliseconds())
-        self.extended_timeout = datetime.timedelta(0, 0, 0, value)
-    
     # Interval - property
     @dbus_service_property(_interface, signature="t",
                            access="readwrite")
@@ -1365,15 +1114,17 @@
         if value is None:       # get
             return dbus.UInt64(self.interval_milliseconds())
         self.interval = datetime.timedelta(0, 0, 0, value)
+        # Emit D-Bus signal
+        self.PropertyChanged(dbus.String("Interval"),
+                             dbus.UInt64(value, variant_level=1))
         if getattr(self, "checker_initiator_tag", None) is None:
             return
-        if self.enabled:
-            # Reschedule checker run
-            gobject.source_remove(self.checker_initiator_tag)
-            self.checker_initiator_tag = (gobject.timeout_add
-                                          (value, self.start_checker))
-            self.start_checker()    # Start one now, too
-    
+        # Reschedule checker run
+        gobject.source_remove(self.checker_initiator_tag)
+        self.checker_initiator_tag = (gobject.timeout_add
+                                      (value, self.start_checker))
+        self.start_checker()    # Start one now, too
+
     # Checker - property
     @dbus_service_property(_interface, signature="s",
                            access="readwrite")
@@ -1381,6 +1132,10 @@
         if value is None:       # get
             return dbus.String(self.checker_command)
         self.checker_command = value
+        # Emit D-Bus signal
+        self.PropertyChanged(dbus.String("Checker"),
+                             dbus.String(self.checker_command,
+                                         variant_level=1))
     
     # CheckerRunning - property
     @dbus_service_property(_interface, signature="b",
@@ -1413,7 +1168,7 @@
         self._pipe.send(('init', fpr, address))
         if not self._pipe.recv():
             raise KeyError()
-    
+
     def __getattribute__(self, name):
         if(name == '_pipe'):
             return super(ProxyClient, self).__getattribute__(name)
@@ -1426,17 +1181,13 @@
                 self._pipe.send(('funcall', name, args, kwargs))
                 return self._pipe.recv()[1]
             return func
-    
+
     def __setattr__(self, name, value):
         if(name == '_pipe'):
             return super(ProxyClient, self).__setattr__(name, value)
         self._pipe.send(('setattr', name, value))
 
 
-class ClientDBusTransitional(ClientDBus):
-    __metaclass__ = AlternateDBusNamesMetaclass
-
-
 class ClientHandler(socketserver.BaseRequestHandler, object):
     """A class to handle client connections.
     
@@ -1449,17 +1200,17 @@
                         unicode(self.client_address))
             logger.debug("Pipe FD: %d",
                          self.server.child_pipe.fileno())
-            
+
             session = (gnutls.connection
                        .ClientSession(self.request,
                                       gnutls.connection
                                       .X509Credentials()))
-            
+
             # Note: gnutls.connection.X509Credentials is really a
             # generic GnuTLS certificate credentials object so long as
             # no X.509 keys are added to it.  Therefore, we can use it
             # here despite using OpenPGP certificates.
-            
+
             #priority = ':'.join(("NONE", "+VERS-TLS1.1",
             #                      "+AES-256-CBC", "+SHA1",
             #                      "+COMP-NULL", "+CTYPE-OPENPGP",
@@ -1471,7 +1222,7 @@
             (gnutls.library.functions
              .gnutls_priority_set_direct(session._c_object,
                                          priority, None))
-            
+
             # Start communication using the Mandos protocol
             # Get protocol number
             line = self.request.makefile().readline()
@@ -1482,7 +1233,7 @@
             except (ValueError, IndexError, RuntimeError) as error:
                 logger.error("Unknown protocol version: %s", error)
                 return
-            
+
             # Start GnuTLS connection
             try:
                 session.handshake()
@@ -1492,7 +1243,7 @@
                 # established.  Just abandon the request.
                 return
             logger.debug("Handshake succeeded")
-            
+
             approval_required = False
             try:
                 try:
@@ -1503,10 +1254,7 @@
                     logger.warning("Bad certificate: %s", error)
                     return
                 logger.debug("Fingerprint: %s", fpr)
-                if self.server.use_dbus:
-                    # Emit D-Bus signal
-                    client.NewRequest(str(self.client_address))
-                
+
                 try:
                     client = ProxyClient(child_pipe, fpr,
                                          self.client_address)
@@ -1524,7 +1272,7 @@
                                        client.name)
                         if self.server.use_dbus:
                             # Emit D-Bus signal
-                            client.Rejected("Disabled")
+                            client.Rejected("Disabled")                    
                         return
                     
                     if client._approved or not client.approval_delay:
@@ -1547,11 +1295,10 @@
                         return
                     
                     #wait until timeout or approved
+                    #x = float(client._timedelta_to_milliseconds(delay))
                     time = datetime.datetime.now()
                     client.changedstate.acquire()
-                    (client.changedstate.wait
-                     (float(client._timedelta_to_milliseconds(delay)
-                            / 1000)))
+                    client.changedstate.wait(float(client._timedelta_to_milliseconds(delay) / 1000))
                     client.changedstate.release()
                     time2 = datetime.datetime.now()
                     if (time2 - time) >= delay:
@@ -1579,10 +1326,10 @@
                                  sent, len(client.secret)
                                  - (sent_size + sent))
                     sent_size += sent
-                
+
                 logger.info("Sending secret to %s", client.name)
-                # bump the timeout using extended_timeout
-                client.checked_ok(client.extended_timeout)
+                # bump the timeout as if seen
+                client.checked_ok()
                 if self.server.use_dbus:
                     # Emit D-Bus signal
                     client.GotSecret()
@@ -1655,7 +1402,7 @@
         # Convert the buffer to a Python bytestring
         fpr = ctypes.string_at(buf, buf_len.value)
         # Convert the bytestring to hexadecimal notation
-        hex_fpr = binascii.hexlify(fpr).upper()
+        hex_fpr = ''.join("%02X" % ord(char) for char in fpr)
         return hex_fpr
 
 
@@ -1667,15 +1414,11 @@
         except:
             self.handle_error(request, address)
         self.close_request(request)
-    
+            
     def process_request(self, request, address):
         """Start a new process to process the request."""
-        proc = multiprocessing.Process(target = self.sub_process_main,
-                                       args = (request,
-                                               address))
-        proc.start()
-        return proc
-
+        multiprocessing.Process(target = self.sub_process_main,
+                                args = (request, address)).start()
 
 class MultiprocessingMixInWithPipe(MultiprocessingMixIn, object):
     """ adds a pipe to the MixIn """
@@ -1685,17 +1428,16 @@
         This function creates a new pipe in self.pipe
         """
         parent_pipe, self.child_pipe = multiprocessing.Pipe()
-        
-        proc = MultiprocessingMixIn.process_request(self, request,
-                                                    client_address)
+
+        super(MultiprocessingMixInWithPipe,
+              self).process_request(request, client_address)
         self.child_pipe.close()
-        self.add_pipe(parent_pipe, proc)
-    
-    def add_pipe(self, parent_pipe, proc):
+        self.add_pipe(parent_pipe)
+
+    def add_pipe(self, parent_pipe):
         """Dummy function; override as necessary"""
         raise NotImplementedError
 
-
 class IPv6_TCPServer(MultiprocessingMixInWithPipe,
                      socketserver.TCPServer, object):
     """IPv6-capable TCP server.  Accepts 'None' as address and/or port
@@ -1775,7 +1517,7 @@
         self.enabled = False
         self.clients = clients
         if self.clients is None:
-            self.clients = {}
+            self.clients = set()
         self.use_dbus = use_dbus
         self.gnutls_priority = gnutls_priority
         IPv6_TCPServer.__init__(self, server_address,
@@ -1785,21 +1527,17 @@
     def server_activate(self):
         if self.enabled:
             return socketserver.TCPServer.server_activate(self)
-    
     def enable(self):
         self.enabled = True
-    
-    def add_pipe(self, parent_pipe, proc):
+    def add_pipe(self, parent_pipe):
         # Call "handle_ipc" for both data and EOF events
         gobject.io_add_watch(parent_pipe.fileno(),
                              gobject.IO_IN | gobject.IO_HUP,
                              functools.partial(self.handle_ipc,
-                                               parent_pipe =
-                                               parent_pipe,
-                                               proc = proc))
-    
+                                               parent_pipe = parent_pipe))
+        
     def handle_ipc(self, source, condition, parent_pipe=None,
-                   proc = None, client_object=None):
+                   client_object=None):
         condition_names = {
             gobject.IO_IN: "IN",   # There is data to read.
             gobject.IO_OUT: "OUT", # Data can be written (without
@@ -1814,10 +1552,8 @@
                                        for cond, name in
                                        condition_names.iteritems()
                                        if cond & condition)
-        # error, or the other end of multiprocessing.Pipe has closed
+        # error or the other end of multiprocessing.Pipe has closed
         if condition & (gobject.IO_ERR | condition & gobject.IO_HUP):
-            # Wait for other process to exit
-            proc.join()
             return False
         
         # Read a request from the child
@@ -1828,7 +1564,7 @@
             fpr = request[1]
             address = request[2]
             
-            for c in self.clients.itervalues():
+            for c in self.clients:
                 if c.fingerprint == fpr:
                     client = c
                     break
@@ -1837,45 +1573,37 @@
                             "dress: %s", fpr, address)
                 if self.use_dbus:
                     # Emit D-Bus signal
-                    mandos_dbus_service.ClientNotFound(fpr,
-                                                       address[0])
+                    mandos_dbus_service.ClientNotFound(fpr, address[0])
                 parent_pipe.send(False)
                 return False
             
             gobject.io_add_watch(parent_pipe.fileno(),
                                  gobject.IO_IN | gobject.IO_HUP,
                                  functools.partial(self.handle_ipc,
-                                                   parent_pipe =
-                                                   parent_pipe,
-                                                   proc = proc,
-                                                   client_object =
-                                                   client))
+                                                   parent_pipe = parent_pipe,
+                                                   client_object = client))
             parent_pipe.send(True)
-            # remove the old hook in favor of the new above hook on
-            # same fileno
+            # remove the old hook in favor of the new above hook on same fileno
             return False
         if command == 'funcall':
             funcname = request[1]
             args = request[2]
             kwargs = request[3]
             
-            parent_pipe.send(('data', getattr(client_object,
-                                              funcname)(*args,
-                                                         **kwargs)))
-        
+            parent_pipe.send(('data', getattr(client_object, funcname)(*args, **kwargs)))
+
         if command == 'getattr':
             attrname = request[1]
             if callable(client_object.__getattribute__(attrname)):
                 parent_pipe.send(('function',))
             else:
-                parent_pipe.send(('data', client_object
-                                  .__getattribute__(attrname)))
+                parent_pipe.send(('data', client_object.__getattribute__(attrname)))
         
         if command == 'setattr':
             attrname = request[1]
             value = request[2]
             setattr(client_object, attrname, value)
-        
+
         return True
 
 
@@ -1918,6 +1646,30 @@
     return timevalue
 
 
+def if_nametoindex(interface):
+    """Call the C function if_nametoindex(), or equivalent
+    
+    Note: This function cannot accept a unicode string."""
+    global if_nametoindex
+    try:
+        if_nametoindex = (ctypes.cdll.LoadLibrary
+                          (ctypes.util.find_library("c"))
+                          .if_nametoindex)
+    except (OSError, AttributeError):
+        logger.warning("Doing if_nametoindex the hard way")
+        def if_nametoindex(interface):
+            "Get an interface index the hard way, i.e. using fcntl()"
+            SIOCGIFINDEX = 0x8933  # From /usr/include/linux/sockios.h
+            with contextlib.closing(socket.socket()) as s:
+                ifreq = fcntl.ioctl(s, SIOCGIFINDEX,
+                                    struct.pack(str("16s16x"),
+                                                interface))
+            interface_index = struct.unpack(str("I"),
+                                            ifreq[16:20])[0]
+            return interface_index
+    return if_nametoindex(interface)
+
+
 def daemon(nochdir = False, noclose = False):
     """See daemon(3).  Standard BSD Unix function.
     
@@ -1978,12 +1730,6 @@
                         " system bus interface")
     parser.add_argument("--no-ipv6", action="store_false",
                         dest="use_ipv6", help="Do not use IPv6")
-    parser.add_argument("--no-restore", action="store_false",
-                        dest="restore", help="Do not restore stored"
-                        " state")
-    parser.add_argument("--statedir", metavar="DIR",
-                        help="Directory to save/restore state in")
-    
     options = parser.parse_args()
     
     if options.check:
@@ -2002,8 +1748,6 @@
                         "use_dbus": "True",
                         "use_ipv6": "True",
                         "debuglevel": "",
-                        "restore": "True",
-                        "statedir": "/var/lib/mandos"
                         }
     
     # Parse config file for server-global settings
@@ -2026,8 +1770,7 @@
     # options, if set.
     for option in ("interface", "address", "port", "debug",
                    "priority", "servicename", "configdir",
-                   "use_dbus", "use_ipv6", "debuglevel", "restore",
-                   "statedir"):
+                   "use_dbus", "use_ipv6", "debuglevel"):
         value = getattr(options, option)
         if value is not None:
             server_settings[option] = value
@@ -2045,18 +1788,7 @@
     debuglevel = server_settings["debuglevel"]
     use_dbus = server_settings["use_dbus"]
     use_ipv6 = server_settings["use_ipv6"]
-    stored_state_path = os.path.join(server_settings["statedir"],
-                                     stored_state_file)
-    
-    if debug:
-        initlogger(logging.DEBUG)
-    else:
-        if not debuglevel:
-            initlogger()
-        else:
-            level = getattr(logging, debuglevel.upper())
-            initlogger(level)
-    
+
     if server_settings["servicename"] != "Mandos":
         syslogger.setFormatter(logging.Formatter
                                ('Mandos (%s) [%%(process)d]:'
@@ -2064,9 +1796,8 @@
                                 % server_settings["servicename"]))
     
     # Parse config file with clients
-    client_defaults = { "timeout": "5m",
-                        "extended_timeout": "15m",
-                        "interval": "2m",
+    client_defaults = { "timeout": "1h",
+                        "interval": "5m",
                         "checker": "fping -q -- %%(host)s",
                         "host": "",
                         "approval_delay": "0s",
@@ -2116,6 +1847,14 @@
         if error[0] != errno.EPERM:
             raise error
     
+    if not debug and not debuglevel:
+        syslogger.setLevel(logging.WARNING)
+        console.setLevel(logging.WARNING)
+    if debuglevel:
+        level = getattr(logging, debuglevel.upper())
+        syslogger.setLevel(level)
+        console.setLevel(level)
+
     if debug:
         # Enable all possible GnuTLS debugging
         
@@ -2152,21 +1891,17 @@
     # End of Avahi example code
     if use_dbus:
         try:
-            bus_name = dbus.service.BusName("se.recompile.Mandos",
+            bus_name = dbus.service.BusName("se.bsnet.fukt.Mandos",
                                             bus, do_not_queue=True)
-            old_bus_name = (dbus.service.BusName
-                            ("se.bsnet.fukt.Mandos", bus,
-                             do_not_queue=True))
         except dbus.exceptions.NameExistsException as e:
             logger.error(unicode(e) + ", disabling D-Bus")
             use_dbus = False
             server_settings["use_dbus"] = False
             tcp_server.use_dbus = False
     protocol = avahi.PROTO_INET6 if use_ipv6 else avahi.PROTO_INET
-    service = AvahiServiceToSyslog(name =
-                                   server_settings["servicename"],
-                                   servicetype = "_mandos._tcp",
-                                   protocol = protocol, bus = bus)
+    service = AvahiService(name = server_settings["servicename"],
+                           servicetype = "_mandos._tcp",
+                           protocol = protocol, bus = bus)
     if server_settings["interface"]:
         service.interface = (if_nametoindex
                              (str(server_settings["interface"])))
@@ -2176,133 +1911,24 @@
     
     client_class = Client
     if use_dbus:
-        client_class = functools.partial(ClientDBusTransitional,
-                                         bus = bus)
-    
-    special_settings = {
-        # Some settings need to be accessd by special methods;
-        # booleans need .getboolean(), etc.  Here is a list of them:
-        "approved_by_default":
-            lambda section:
-            client_config.getboolean(section, "approved_by_default"),
-        "enabled":
-            lambda section:
-            client_config.getboolean(section, "enabled"),
-        }
-    # Construct a new dict of client settings of this form:
-    # { client_name: {setting_name: value, ...}, ...}
-    # with exceptions for any special settings as defined above
-    client_settings = dict((clientname,
-                           dict((setting,
-                                 (value
-                                  if setting not in special_settings
-                                  else special_settings[setting]
-                                  (clientname)))
-                                for setting, value in
-                                client_config.items(clientname)))
-                          for clientname in client_config.sections())
-    
-    old_client_settings = {}
-    clients_data = []
-    
-    # Get client data and settings from last running state.
-    if server_settings["restore"]:
-        try:
-            with open(stored_state_path, "rb") as stored_state:
-                clients_data, old_client_settings = (pickle.load
-                                                     (stored_state))
-            os.remove(stored_state_path)
-        except IOError as e:
-            logger.warning("Could not load persistent state: {0}"
-                           .format(e))
-            if e.errno != errno.ENOENT:
-                raise
-    
-    with PGPEngine() as pgp:
-        for client in clients_data:
-            client_name = client["name"]
-            
-            # Decide which value to use after restoring saved state.
-            # We have three different values: Old config file,
-            # new config file, and saved state.
-            # New config value takes precedence if it differs from old
-            # config value, otherwise use saved state.
-            for name, value in client_settings[client_name].items():
-                try:
-                    # For each value in new config, check if it
-                    # differs from the old config value (Except for
-                    # the "secret" attribute)
-                    if (name != "secret" and
-                        value != old_client_settings[client_name]
-                        [name]):
-                        setattr(client, name, value)
-                except KeyError:
-                    pass
-            
-            # Clients who has passed its expire date can still be
-            # enabled if its last checker was sucessful.  Clients
-            # whose checker failed before we stored its state is
-            # assumed to have failed all checkers during downtime.
-            if client["enabled"] and client["last_checked_ok"]:
-                if ((datetime.datetime.utcnow()
-                     - client["last_checked_ok"])
-                    > client["interval"]):
-                    if client["last_checker_status"] != 0:
-                        client["enabled"] = False
-                    else:
-                        client["expires"] = (datetime.datetime
-                                             .utcnow()
-                                             + client["timeout"])
-            
-            client["changedstate"] = (multiprocessing_manager
-                                      .Condition
-                                      (multiprocessing_manager
-                                       .Lock()))
-            if use_dbus:
-                new_client = (ClientDBusTransitional.__new__
-                              (ClientDBusTransitional))
-                tcp_server.clients[client_name] = new_client
-                new_client.bus = bus
-                for name, value in client.iteritems():
-                    setattr(new_client, name, value)
-                client_object_name = unicode(client_name).translate(
-                    {ord("."): ord("_"),
-                     ord("-"): ord("_")})
-                new_client.dbus_object_path = (dbus.ObjectPath
-                                               ("/clients/"
-                                                + client_object_name))
-                DBusObjectWithProperties.__init__(new_client,
-                                                  new_client.bus,
-                                                  new_client
-                                                  .dbus_object_path)
-            else:
-                tcp_server.clients[client_name] = (Client.__new__
-                                                   (Client))
-                for name, value in client.iteritems():
-                    setattr(tcp_server.clients[client_name],
-                            name, value)
-            
+        client_class = functools.partial(ClientDBus, bus = bus)
+    def client_config_items(config, section):
+        special_settings = {
+            "approved_by_default":
+                lambda: config.getboolean(section,
+                                          "approved_by_default"),
+            }
+        for name, value in config.items(section):
             try:
-                tcp_server.clients[client_name].secret = (
-                    pgp.decrypt(tcp_server.clients[client_name]
-                                .encrypted_secret,
-                                client_settings[client_name]
-                                ["secret"]))
-            except PGPError:
-                # If decryption fails, we use secret from new settings
-                tcp_server.clients[client_name].secret = (
-                    client_settings[client_name]["secret"])
-    
-    # Create/remove clients based on new changes made to config
-    for clientname in set(old_client_settings) - set(client_settings):
-        del tcp_server.clients[clientname]
-    for clientname in set(client_settings) - set(old_client_settings):
-        tcp_server.clients[clientname] = (client_class(name
-                                                       = clientname,
-                                                       config =
-                                                       client_settings
-                                                       [clientname]))
-    
+                yield (name, special_settings[name]())
+            except KeyError:
+                yield (name, value)
+    
+    tcp_server.clients.update(set(
+            client_class(name = section,
+                         config= dict(client_config_items(
+                        client_config, section)))
+            for section in client_config.sections()))
     if not tcp_server.clients:
         logger.warning("No clients defined")
         
@@ -2321,7 +1947,7 @@
         del pidfilename
         
         signal.signal(signal.SIGINT, signal.SIG_IGN)
-    
+
     signal.signal(signal.SIGHUP, lambda signum, frame: sys.exit())
     signal.signal(signal.SIGTERM, lambda signum, frame: sys.exit())
     
@@ -2330,7 +1956,7 @@
             """A D-Bus proxy object"""
             def __init__(self):
                 dbus.service.Object.__init__(self, bus, "/")
-            _interface = "se.recompile.Mandos"
+            _interface = "se.bsnet.fukt.Mandos"
             
             @dbus.service.signal(_interface, signature="o")
             def ClientAdded(self, objpath):
@@ -2351,8 +1977,7 @@
             def GetAllClients(self):
                 "D-Bus method"
                 return dbus.Array(c.dbus_object_path
-                                  for c in
-                                  tcp_server.clients.itervalues())
+                                  for c in tcp_server.clients)
             
             @dbus.service.method(_interface,
                                  out_signature="a{oa{sv}}")
@@ -2360,15 +1985,15 @@
                 "D-Bus method"
                 return dbus.Dictionary(
                     ((c.dbus_object_path, c.GetAll(""))
-                     for c in tcp_server.clients.itervalues()),
+                     for c in tcp_server.clients),
                     signature="oa{sv}")
             
             @dbus.service.method(_interface, in_signature="o")
             def RemoveClient(self, object_path):
                 "D-Bus method"
-                for c in tcp_server.clients.itervalues():
+                for c in tcp_server.clients:
                     if c.dbus_object_path == object_path:
-                        del tcp_server.clients[c.name]
+                        tcp_server.clients.remove(c)
                         c.remove_from_connection()
                         # Don't signal anything except ClientRemoved
                         c.disable(quiet=True)
@@ -2379,79 +2004,31 @@
             
             del _interface
         
-        class MandosDBusServiceTransitional(MandosDBusService):
-            __metaclass__ = AlternateDBusNamesMetaclass
-        mandos_dbus_service = MandosDBusServiceTransitional()
+        mandos_dbus_service = MandosDBusService()
     
     def cleanup():
         "Cleanup function; run on exit"
         service.cleanup()
         
-        multiprocessing.active_children()
-        if not (tcp_server.clients or client_settings):
-            return
-        
-        # Store client before exiting. Secrets are encrypted with key
-        # based on what config file has. If config file is
-        # removed/edited, old secret will thus be unrecovable.
-        clients = []
-        with PGPEngine() as pgp:
-            for client in tcp_server.clients.itervalues():
-                key = client_settings[client.name]["secret"]
-                client.encrypted_secret = pgp.encrypt(client.secret,
-                                                      key)
-                client_dict = {}
-                
-                # A list of attributes that will not be stored when
-                # shutting down.
-                exclude = set(("bus", "changedstate", "secret"))
-                for name, typ in (inspect.getmembers
-                                  (dbus.service.Object)):
-                    exclude.add(name)
-                
-                client_dict["encrypted_secret"] = (client
-                                                   .encrypted_secret)
-                for attr in client.client_structure:
-                    if attr not in exclude:
-                        client_dict[attr] = getattr(client, attr)
-                
-                clients.append(client_dict)
-                del client_settings[client.name]["secret"]
-        
-        try:
-            with os.fdopen(os.open(stored_state_path,
-                                   os.O_CREAT|os.O_WRONLY|os.O_TRUNC,
-                                   0600), "wb") as stored_state:
-                pickle.dump((clients, client_settings), stored_state)
-        except (IOError, OSError) as e:
-            logger.warning("Could not save persistent state: {0}"
-                           .format(e))
-            if e.errno not in (errno.ENOENT, errno.EACCES):
-                raise
-        
-        # Delete all clients, and settings from config
         while tcp_server.clients:
-            name, client = tcp_server.clients.popitem()
+            client = tcp_server.clients.pop()
             if use_dbus:
                 client.remove_from_connection()
+            client.disable_hook = None
             # Don't signal anything except ClientRemoved
             client.disable(quiet=True)
             if use_dbus:
                 # Emit D-Bus signal
-                mandos_dbus_service.ClientRemoved(client
-                                                  .dbus_object_path,
+                mandos_dbus_service.ClientRemoved(client.dbus_object_path,
                                                   client.name)
-        client_settings.clear()
     
     atexit.register(cleanup)
     
-    for client in tcp_server.clients.itervalues():
+    for client in tcp_server.clients:
         if use_dbus:
             # Emit D-Bus signal
             mandos_dbus_service.ClientAdded(client.dbus_object_path)
-        # Need to initiate checking of clients
-        if client.enabled:
-            client.init_checker()
+        client.enable()
     
     tcp_server.enable()
     tcp_server.server_activate()
@@ -2497,6 +2074,5 @@
     # Must run before the D-Bus bus name gets deregistered
     cleanup()
 
-
 if __name__ == '__main__':
     main()

=== modified file 'mandos-clients.conf.xml'
--- mandos-clients.conf.xml	2011-11-26 23:08:17 +0000
+++ mandos-clients.conf.xml	2011-08-08 21:12:37 +0000
@@ -3,7 +3,7 @@
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY CONFNAME "mandos-clients.conf">
 <!ENTITY CONFPATH "<filename>/etc/mandos/clients.conf</filename>">
-<!ENTITY TIMESTAMP "2011-11-26">
+<!ENTITY TIMESTAMP "2011-08-08">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -20,14 +20,14 @@
 	<firstname>Björn</firstname>
 	<surname>Påhlsson</surname>
 	<address>
-	  <email>belorn@recompile.se</email>
+	  <email>belorn@fukt.bsnet.se</email>
 	</address>
       </author>
       <author>
 	<firstname>Teddy</firstname>
 	<surname>Hogeborn</surname>
 	<address>
-	  <email>teddy@recompile.se</email>
+	  <email>teddy@fukt.bsnet.se</email>
 	</address>
       </author>
     </authorgroup>
@@ -182,29 +182,6 @@
       </varlistentry>
       
       <varlistentry>
-	<term><option>extended_timeout<literal> = </literal><replaceable
-	>TIME</replaceable></option></term>
-	<listitem>
-	  <para>
-	    This option is <emphasis>optional</emphasis>.
-	  </para>
-	  <para>
-	    Extended timeout is an added timeout that is given once
-	    after a password has been sent successfully to a client.
-	    The timeout is by default longer than the normal timeout,
-	    and is used for handling the extra long downtime while a
-	    machine is booting up.  Time to take into consideration
-	    when changing this value is file system checks and quota
-	    checks.  The default value is 15 minutes.
-	  </para>
-	  <para>
-	    The format of <replaceable>TIME</replaceable> is the same
-	    as for <varname>timeout</varname> below.
-	  </para>
-	</listitem>
-      </varlistentry>
-      
-      <varlistentry>
 	<term><option>fingerprint<literal> = </literal
 	><replaceable>HEXSTRING</replaceable></option></term>
 	<listitem>
@@ -252,7 +229,7 @@
 	    will wait for a checker to complete until the below
 	    <quote><varname>timeout</varname></quote> occurs, at which
 	    time the client will be disabled, and any running checker
-	    killed.  The default interval is 2 minutes.
+	    killed.  The default interval is 5 minutes.
 	  </para>
 	  <para>
 	    The format of <replaceable>TIME</replaceable> is the same
@@ -322,11 +299,10 @@
 	    This option is <emphasis>optional</emphasis>.
 	  </para>
 	  <para>
-	    The timeout is how long the server will wait, after a
-	    successful checker run, until a client is disabled and not
-	    allowed to get the data this server holds.  By default
-	    Mandos will use 5 minutes.  See also the
-	    <option>extended_timeout</option> option.
+	    The timeout is how long the server will wait (for either a
+	    successful checker run or a client receiving its secret)
+	    until a client is disabled and not allowed to get the data
+	    this server holds.  By default Mandos will use 1 hour.
 	  </para>
 	  <para>
 	    The <replaceable>TIME</replaceable> is specified as a
@@ -344,20 +320,6 @@
 	</listitem>
       </varlistentry>
       
-      <varlistentry>
-	<term><option>enabled<literal> = </literal>{ <literal
-	>1</literal> | <literal>yes</literal> |	<literal>true</literal
-	> | <literal >on</literal> | <literal>0</literal> | <literal
-	>no</literal> | <literal>false</literal> | <literal
-	>off</literal> }</option></term>
-	<listitem>
-	  <para>
-	    Whether this client should be enabled by default.  The
-	    default is <quote>true</quote>.
-	  </para>
-	</listitem>
-      </varlistentry>
-      
     </variablelist>
   </refsect1>
   
@@ -458,8 +420,8 @@
     <informalexample>
       <programlisting>
 [DEFAULT]
-timeout = 5m
-interval = 2m
+timeout = 1h
+interval = 5m
 checker = fping -q -- %%(host)s
 
 # Client "foo"

=== modified file 'mandos-ctl'
--- mandos-ctl	2011-10-15 16:48:03 +0000
+++ mandos-ctl	2011-07-27 17:58:27 +0000
@@ -3,8 +3,8 @@
 # 
 # Mandos Monitor - Control and monitor the Mandos server
 # 
-# Copyright © 2008-2011 Teddy Hogeborn
-# Copyright © 2008-2011 Björn Påhlsson
+# Copyright © 2008-2010 Teddy Hogeborn
+# Copyright © 2008-2010 Björn Påhlsson
 # 
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -19,7 +19,7 @@
 # You should have received a copy of the GNU General Public License
 # along with this program.  If not, see <http://www.gnu.org/licenses/>.
 # 
-# Contact the authors at <mandos@recompile.se>.
+# Contact the authors at <mandos@fukt.bsnet.se>.
 # 
 
 from __future__ import (division, absolute_import, print_function,
@@ -52,15 +52,14 @@
     "ApprovalDelay": "Approval Delay",
     "ApprovalDuration": "Approval Duration",
     "Checker": "Checker",
-    "ExtendedTimeout" : "Extended Timeout"
     }
 defaultkeywords = ("Name", "Enabled", "Timeout", "LastCheckedOK")
-domain = "se.recompile"
+domain = "se.bsnet.fukt"
 busname = domain + ".Mandos"
 server_path = "/"
 server_interface = domain + ".Mandos"
 client_interface = domain + ".Mandos.Client"
-version = "1.4.1"
+version = "1.3.1"
 
 def timedelta_to_milliseconds(td):
     """Convert a datetime.timedelta object to milliseconds"""
@@ -150,7 +149,6 @@
                 options.remove,
                 options.checker is not None,
                 options.timeout is not None,
-                options.extended_timeout is not None,
                 options.interval is not None,
                 options.approved_by_default is not None,
                 options.approval_delay is not None,
@@ -187,8 +185,6 @@
                         help="Set checker command for client")
     parser.add_argument("-t", "--timeout",
                         help="Set timeout for client")
-    parser.add_argument("--extended-timeout",
-                        help="Set extended timeout for client")
     parser.add_argument("-i", "--interval",
                         help="Set checker interval for client")
     parser.add_argument("--approve-by-default", action="store_true",
@@ -274,8 +270,7 @@
                         "LastEnabled", "ApprovalPending",
                         "ApprovedByDefault",
                         "LastApprovalRequest", "ApprovalDelay",
-                        "ApprovalDuration", "Checker",
-                        "ExtendedTimeout")
+                        "ApprovalDuration", "Checker")
         else:
             keywords = defaultkeywords
         
@@ -301,41 +296,36 @@
                                          dbus_interface=
                                          dbus.PROPERTIES_IFACE)
                          else 1)
-            if options.checker is not None:
+            if options.checker:
                 client.Set(client_interface, "Checker",
                            options.checker,
                            dbus_interface=dbus.PROPERTIES_IFACE)
-            if options.host is not None:
+            if options.host:
                 client.Set(client_interface, "Host", options.host,
                            dbus_interface=dbus.PROPERTIES_IFACE)
-            if options.interval is not None:
+            if options.interval:
                 client.Set(client_interface, "Interval",
                            timedelta_to_milliseconds
                            (string_to_delta(options.interval)),
                            dbus_interface=dbus.PROPERTIES_IFACE)
-            if options.approval_delay is not None:
+            if options.approval_delay:
                 client.Set(client_interface, "ApprovalDelay",
                            timedelta_to_milliseconds
                            (string_to_delta(options.
                                             approval_delay)),
                            dbus_interface=dbus.PROPERTIES_IFACE)
-            if options.approval_duration is not None:
+            if options.approval_duration:
                 client.Set(client_interface, "ApprovalDuration",
                            timedelta_to_milliseconds
                            (string_to_delta(options.
                                             approval_duration)),
                            dbus_interface=dbus.PROPERTIES_IFACE)
-            if options.timeout is not None:
+            if options.timeout:
                 client.Set(client_interface, "Timeout",
                            timedelta_to_milliseconds
                            (string_to_delta(options.timeout)),
                            dbus_interface=dbus.PROPERTIES_IFACE)
-            if options.extended_timeout is not None:
-                client.Set(client_interface, "ExtendedTimeout",
-                           timedelta_to_milliseconds
-                           (string_to_delta(options.extended_timeout)),
-                           dbus_interface=dbus.PROPERTIES_IFACE)
-            if options.secret is not None:
+            if options.secret:
                 client.Set(client_interface, "Secret",
                            dbus.ByteArray(open(options.secret,
                                                "rb").read()),

=== modified file 'mandos-ctl.xml'
--- mandos-ctl.xml	2011-10-05 16:00:56 +0000
+++ mandos-ctl.xml	2011-08-08 21:12:37 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos-ctl">
-<!ENTITY TIMESTAMP "2011-10-03">
+<!ENTITY TIMESTAMP "2011-08-08">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -19,14 +19,14 @@
 	<firstname>Björn</firstname>
 	<surname>Påhlsson</surname>
 	<address>
-	  <email>belorn@recompile.se</email>
+	  <email>belorn@fukt.bsnet.se</email>
 	</address>
       </author>
       <author>
 	<firstname>Teddy</firstname>
 	<surname>Hogeborn</surname>
 	<address>
-	  <email>teddy@recompile.se</email>
+	  <email>teddy@fukt.bsnet.se</email>
 	</address>
       </author>
     </authorgroup>
@@ -95,11 +95,6 @@
       </group>
       <sbr/>
       <group>
-	<arg choice="plain"><option>--extended-timeout
-	<replaceable>TIME</replaceable></option></arg>
-      </group>
-      <sbr/>
-      <group>
 	<arg choice="plain"><option>--interval
 	<replaceable>TIME</replaceable></option></arg>
 	<arg choice="plain"><option>-i
@@ -323,19 +318,6 @@
 	  </para>
 	</listitem>
       </varlistentry>
-
-      <varlistentry>
-	<term><option>--extended-timeout
-	<replaceable>TIME</replaceable></option></term>
-	<listitem>
-	  <para>
-	    Set the <varname>extended_timeout</varname> option of the
-	    specified client(s); see <citerefentry><refentrytitle
-	    >mandos-clients.conf</refentrytitle><manvolnum
-	    >5</manvolnum></citerefentry>.
-	  </para>
-	</listitem>
-      </varlistentry>
       
       <varlistentry>
 	<term><option>--interval

=== modified file 'mandos-keygen'
--- mandos-keygen	2011-10-15 16:48:03 +0000
+++ mandos-keygen	2011-07-27 17:58:27 +0000
@@ -18,10 +18,10 @@
 # You should have received a copy of the GNU General Public License
 # along with this program.  If not, see <http://www.gnu.org/licenses/>.
 # 
-# Contact the authors at <mandos@recompile.se>.
+# Contact the authors at <mandos@fukt.bsnet.se>.
 # 
 
-VERSION="1.4.1"
+VERSION="1.3.1"
 
 KEYDIR="/etc/keys/mandos"
 KEYTYPE=DSA
@@ -192,7 +192,7 @@
 shred --remove \"$RINGDIR\"/sec*;
 test -n \"$BATCHFILE\" && rm --force \"$BATCHFILE\"; \
 rm --recursive --force \"$RINGDIR\";
-tty --quiet && stty echo; \
+stty echo; \
 " EXIT
 
 set -e
@@ -289,37 +289,31 @@
     
     FILECOMMENT="Encrypted password for a Mandos client"
     
-    while [ ! -s "$SECFILE" ]; do
-	if [ -n "$PASSFILE" ]; then
-	    cat "$PASSFILE"
+    if [ -n "$PASSFILE" ]; then
+	cat "$PASSFILE"
+    else
+	stty -echo
+	echo -n "Enter passphrase: " >&2
+	first="$(head --lines=1 | tr --delete '\n')"
+	echo >&2
+	echo -n "Repeat passphrase: " >&2
+	second="$(head --lines=1 | tr --delete '\n')"
+	echo >&2
+	stty echo
+	if [ "$first" != "$second" ]; then
+	    echo "Passphrase mismatch" >&2
+	    touch "$RINGDIR"/mismatch
 	else
-	    tty --quiet && stty -echo
-	    read -p "Enter passphrase: " first
-	    tty --quiet && echo >&2
-	    read -p "Repeat passphrase: " second
-	    if tty --quiet; then
-		echo >&2
-		stty echo
-	    fi
-	    if [ "$first" != "$second" ]; then
-		echo "Passphrase mismatch" >&2
-		touch "$RINGDIR"/mismatch
-	    else
-		echo -n "$first"
-	    fi
-	fi | gpg --quiet --batch --no-tty --no-options --enable-dsa2 \
-	    --homedir "$RINGDIR" --trust-model always --armor \
-	    --encrypt --sign --recipient "$FINGERPRINT" --comment \
-	    "$FILECOMMENT" > "$SECFILE"
-	if [ -e "$RINGDIR"/mismatch ]; then
-	    rm --force "$RINGDIR"/mismatch
-	    if tty --quiet; then
-		> "$SECFILE"
-	    else
-		exit 1
-	    fi
+	    echo -n "$first"
 	fi
-    done
+    fi | gpg --quiet --batch --no-tty --no-options --enable-dsa2 \
+	--homedir "$RINGDIR" --trust-model always --armor --encrypt \
+	--sign --recipient "$FINGERPRINT" --comment "$FILECOMMENT" \
+	> "$SECFILE"
+    if [ -e "$RINGDIR"/mismatch ]; then
+	rm --force "$RINGDIR"/mismatch
+	exit 1
+    fi
     
     cat <<-EOF
 	[$KEYNAME]

=== modified file 'mandos-keygen.xml'
--- mandos-keygen.xml	2011-10-05 16:00:56 +0000
+++ mandos-keygen.xml	2011-08-08 21:12:37 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos-keygen">
-<!ENTITY TIMESTAMP "2011-10-03">
+<!ENTITY TIMESTAMP "2011-08-08">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -19,14 +19,14 @@
 	<firstname>Björn</firstname>
 	<surname>Påhlsson</surname>
 	<address>
-	  <email>belorn@recompile.se</email>
+	  <email>belorn@fukt.bsnet.se</email>
 	</address>
       </author>
       <author>
 	<firstname>Teddy</firstname>
 	<surname>Hogeborn</surname>
 	<address>
-	  <email>teddy@recompile.se</email>
+	  <email>teddy@fukt.bsnet.se</email>
 	</address>
       </author>
     </authorgroup>

=== modified file 'mandos-monitor'
--- mandos-monitor	2011-10-15 16:48:03 +0000
+++ mandos-monitor	2011-07-27 17:58:27 +0000
@@ -19,7 +19,7 @@
 # You should have received a copy of the GNU General Public License
 # along with this program.  If not, see <http://www.gnu.org/licenses/>.
 # 
-# Contact the authors at <mandos@recompile.se>.
+# Contact the authors at <mandos@fukt.bsnet.se>.
 # 
 
 from __future__ import (division, absolute_import, print_function,
@@ -49,10 +49,10 @@
 logging.getLogger('dbus.proxies').setLevel(logging.CRITICAL)
 
 # Some useful constants
-domain = 'se.recompile'
+domain = 'se.bsnet.fukt'
 server_interface = domain + '.Mandos'
 client_interface = domain + '.Mandos.Client'
-version = "1.4.1"
+version = "1.3.1"
 
 # Always run in monochrome mode
 urwid.curses_display.curses.has_colors = lambda : False
@@ -200,7 +200,6 @@
         else:
             self._update_timer_callback_lock -= 1
         if old == 0 and self._update_timer_callback_lock:
-            # Will update the shown timer value every second
             self._update_timer_callback_tag = (gobject.timeout_add
                                                (1000,
                                                 self.update_timer))
@@ -315,14 +314,14 @@
                 message = "Denial in %s. (a)pprove?"
             message = message % unicode(timer).rsplit(".", 1)[0]
         elif self.last_checker_failed:
-            # When checker has failed, print a timer until client expires
-            expires = self.properties["Expires"]
-            if expires == "":
-                timer = datetime.timedelta(0)
-            else:
-                expires = datetime.datetime.strptime(expires,
-                                                     '%Y-%m-%dT%H:%M:%S.%f')
-                timer = expires - datetime.datetime.utcnow()
+            timeout = datetime.timedelta(milliseconds
+                                         = self.properties
+                                         ["Timeout"])
+            last_ok = isoformat_to_datetime(
+                max((self.properties["LastCheckedOK"]
+                     or self.properties["Created"]),
+                    self.properties["LastEnabled"]))
+            timer = timeout - (datetime.datetime.utcnow() - last_ok)
             message = ('A checker has failed! Time until client'
                        ' gets disabled: %s'
                            % unicode(timer).rsplit(".", 1)[0])
@@ -347,8 +346,7 @@
             self.update_hook()
     
     def update_timer(self):
-        """called by gobject. Will indefinitely loop until
-        gobject.source_remove() on tag is called"""
+        "called by gobject"
         self.update()
         return True             # Keep calling this
     

=== modified file 'mandos-monitor.xml'
--- mandos-monitor.xml	2011-10-05 16:00:56 +0000
+++ mandos-monitor.xml	2011-08-08 21:12:37 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos-monitor">
-<!ENTITY TIMESTAMP "2011-10-03">
+<!ENTITY TIMESTAMP "2011-08-08">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -19,14 +19,14 @@
 	<firstname>Björn</firstname>
 	<surname>Påhlsson</surname>
 	<address>
-	  <email>belorn@recompile.se</email>
+	  <email>belorn@fukt.bsnet.se</email>
 	</address>
       </author>
       <author>
 	<firstname>Teddy</firstname>
 	<surname>Hogeborn</surname>
 	<address>
-	  <email>teddy@recompile.se</email>
+	  <email>teddy@fukt.bsnet.se</email>
 	</address>
       </author>
     </authorgroup>

=== modified file 'mandos-options.xml'
--- mandos-options.xml	2011-11-26 22:22:20 +0000
+++ mandos-options.xml	2009-02-13 05:38:21 +0000
@@ -86,15 +86,4 @@
     advanced users should consider changing this option</emphasis>.
   </para>
   
-  <para id="restore">
-    This option controls whether the server will restore any state from
-    last time it ran. Default is to try restore last state.
-  </para>
-  
-  <para id="statedir">
-    Directory to save (and restore) state in.  Default is
-    <quote><filename
-    class="directory">/var/lib/mandos</filename></quote>.
-  </para>
-  
 </section>

=== modified file 'mandos.conf'
--- mandos.conf	2011-11-26 22:22:20 +0000
+++ mandos.conf	2009-02-13 05:38:21 +0000
@@ -4,27 +4,33 @@
 # These are the default values for the server, uncomment and change
 # them if needed.
 
+
 # If "interface" is set, the server will only listen to a specific
 # network interface.
 ;interface = 
 
+
 # If "address" is set, the server will only listen to a specific
 # address.  This must currently be an IPv6 address; an IPv4 address
 # can be specified using the "::FFFF:192.0.2.3" syntax.  Also, if this
 # is a link-local address, an interface should be set above.
 ;address =
 
+
 # If "port" is set, the server to bind to that port. By default, the
 # server will listen to an arbitrary port.
 ;port = 
 
+
 # If "debug" is true, the server will run in the foreground and print
 # a lot of debugging information.
 ;debug = False
 
+
 # GnuTLS priority for the TLS handshake.  See gnutls_priority_init(3).
 ;priority = SECURE256:!CTYPE-X.509:+CTYPE-OPENPGP
 
+
 # Zeroconf service name.  You need to change this if you for some
 # reason want to run more than one server on the same *host*.
 # If there are name collisions on the same *network*, the server will
@@ -36,9 +42,3 @@
 
 # Whether to use IPv6.  (Changing this is NOT recommended.)
 ;use_ipv6 = True
-
-# Whether to restore saved state on startup
-;restore = True
-
-# The directory where state is saved
-;statedir = /var/lib/mandos

=== modified file 'mandos.conf.xml'
--- mandos.conf.xml	2011-11-26 22:22:20 +0000
+++ mandos.conf.xml	2011-08-08 21:12:37 +0000
@@ -3,7 +3,7 @@
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY CONFNAME "mandos.conf">
 <!ENTITY CONFPATH "<filename>/etc/mandos/mandos.conf</filename>">
-<!ENTITY TIMESTAMP "2011-11-26">
+<!ENTITY TIMESTAMP "2011-08-08">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -20,14 +20,14 @@
 	<firstname>Björn</firstname>
 	<surname>Påhlsson</surname>
 	<address>
-	  <email>belorn@recompile.se</email>
+	  <email>belorn@fukt.bsnet.se</email>
 	</address>
       </author>
       <author>
 	<firstname>Teddy</firstname>
 	<surname>Hogeborn</surname>
 	<address>
-	  <email>teddy@recompile.se</email>
+	  <email>teddy@fukt.bsnet.se</email>
 	</address>
       </author>
     </authorgroup>
@@ -154,25 +154,6 @@
 	</listitem>
       </varlistentry>
       
-      <varlistentry>
-	<term><option>restore<literal> = </literal>{ <literal
-	  >1</literal> | <literal>yes</literal> | <literal
-	  >true</literal> | <literal>on</literal> | <literal
-	  >0</literal> | <literal>no</literal> | <literal
-	  >false</literal> | <literal>off</literal> }</option></term>
-	<listitem>
-	  <xi:include href="mandos-options.xml" xpointer="restore"/>
-	</listitem>
-      </varlistentry>
-      
-      <varlistentry>
-	<term><option>statedir<literal> = </literal><replaceable
-	>DIRECTORY</replaceable></option></term>
-	<listitem>
-	  <xi:include href="mandos-options.xml" xpointer="statedir"/>
-	</listitem>
-      </varlistentry>
-      
     </variablelist>
   </refsect1>
   
@@ -217,8 +198,6 @@
 servicename = Daena
 use_dbus = False
 use_ipv6 = True
-restore = True
-statedir = /var/lib/mandos
       </programlisting>
     </informalexample>
   </refsect1>

=== modified file 'mandos.lsm'
--- mandos.lsm	2011-10-15 16:48:03 +0000
+++ mandos.lsm	2011-07-27 17:58:27 +0000
@@ -1,20 +1,20 @@
 Begin4
 Title:		Mandos
-Version:	1.4.1
-Entered-date:	2011-10-15
+Version:	1.3.1
+Entered-date:	2011-07-27
 Description:	The Mandos system allows computers to have encrypted
 root file systems and at the same time be capable of remote and/or
 unattended reboots.
 Keywords:	boot, encryption, luks, cryptsetup, network, openpgp,
 tls, dm-crypt
-Author:		teddy@recompile.se (Teddy Hogeborn),
-		belorn@recompile.se (Björn Påhlsson)
-Maintained-by:	teddy@recompile.se (Teddy Hogeborn),
-		belorn@recompile.se (Björn Påhlsson)
-Primary-site: http://www.recompile.se/mandos
-	      138K mandos_1.4.1.orig.tar.gz
-Alternate-site: ftp://ftp.recompile.se/pub/mandos
-		138K mandos_1.4.1.orig.tar.gz
+Author:		teddy@fukt.bsnet.se (Teddy Hogeborn),
+		belorn@fukt.bsnet.se (Björn Påhlsson)
+Maintained-by:	teddy@fukt.bsnet.se (Teddy Hogeborn),
+		belorn@fukt.bsnet.se (Björn Påhlsson)
+Primary-site: http://www.fukt.bsnet.se/mandos
+	      136K mandos_1.3.1.orig.tar.gz
+Alternate-site: ftp://ftp.fukt.bsnet.se/pub/mandos
+		136K mandos_1.3.1.orig.tar.gz
 Platforms:	Requires GCC, GNU libC, Avahi, GnuPG, Python 2.6, and
 various other libraries.  While made for Debian GNU/Linux, it is
 probably portable to other distributions, but not other Unixes.

=== modified file 'mandos.xml'
--- mandos.xml	2011-11-26 22:22:20 +0000
+++ mandos.xml	2011-08-08 21:12:37 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 "http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos">
-<!ENTITY TIMESTAMP "2011-11-26">
+<!ENTITY TIMESTAMP "2011-08-08">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -19,14 +19,14 @@
 	<firstname>Björn</firstname>
 	<surname>Påhlsson</surname>
 	<address>
-	  <email>belorn@recompile.se</email>
+	  <email>belorn@fukt.bsnet.se</email>
 	</address>
       </author>
       <author>
 	<firstname>Teddy</firstname>
 	<surname>Hogeborn</surname>
 	<address>
-	  <email>teddy@recompile.se</email>
+	  <email>teddy@fukt.bsnet.se</email>
 	</address>
       </author>
     </authorgroup>
@@ -94,11 +94,6 @@
       <arg><option>--no-dbus</option></arg>
       <sbr/>
       <arg><option>--no-ipv6</option></arg>
-      <sbr/>
-      <arg><option>--no-restore</option></arg>
-      <sbr/>
-      <arg><option>--statedir
-      <replaceable>DIRECTORY</replaceable></option></arg>
     </cmdsynopsis>
     <cmdsynopsis>
       <command>&COMMANDNAME;</command>
@@ -122,16 +117,14 @@
     <para>
       <command>&COMMANDNAME;</command> is a server daemon which
       handles incoming request for passwords for a pre-defined list of
-      client host computers. For an introduction, see
-      <citerefentry><refentrytitle>intro</refentrytitle>
-      <manvolnum>8mandos</manvolnum></citerefentry>. The Mandos server
-      uses Zeroconf to announce itself on the local network, and uses
-      TLS to communicate securely with and to authenticate the
-      clients.  The Mandos server uses IPv6 to allow Mandos clients to
-      use IPv6 link-local addresses, since the clients will probably
-      not have any other addresses configured (see <xref
-      linkend="overview"/>).  Any authenticated client is then given
-      the stored pre-encrypted password for that specific client.
+      client host computers.  The Mandos server uses Zeroconf to
+      announce itself on the local network, and uses TLS to
+      communicate securely with and to authenticate the clients.  The
+      Mandos server uses IPv6 to allow Mandos clients to use IPv6
+      link-local addresses, since the clients will probably not have
+      any other addresses configured (see <xref linkend="overview"/>).
+      Any authenticated client is then given the stored pre-encrypted
+      password for that specific client.
     </para>
   </refsect1>
   
@@ -280,21 +273,6 @@
 	  <xi:include href="mandos-options.xml" xpointer="ipv6"/>
 	</listitem>
       </varlistentry>
-      
-      <varlistentry>
-	<term><option>--no-restore</option></term>
-	<listitem>
-	  <xi:include href="mandos-options.xml" xpointer="restore"/>
-	</listitem>
-      </varlistentry>
-      
-      <varlistentry>
-	<term><option>--statedir
-	<replaceable>DIRECTORY</replaceable></option></term>
-	<listitem>
-	  <xi:include href="mandos-options.xml" xpointer="statedir"/>
-	</listitem>
-      </varlistentry>
     </variablelist>
   </refsect1>
   
@@ -374,9 +352,9 @@
       for some time, the client is assumed to be compromised and is no
       longer eligible to receive the encrypted password.  (Manual
       intervention is required to re-enable a client.)  The timeout,
-      extended timeout, checker program, and interval between checks
-      can be configured both globally and per client; see
-      <citerefentry><refentrytitle>mandos-clients.conf</refentrytitle>
+      checker program, and interval between checks can be configured
+      both globally and per client; see <citerefentry>
+      <refentrytitle>mandos-clients.conf</refentrytitle>
       <manvolnum>5</manvolnum></citerefentry>.  A client successfully
       receiving its password will also be treated as a successful
       checker run.
@@ -489,17 +467,6 @@
 	</listitem>
       </varlistentry>
       <varlistentry>
-	<term><filename
-	class="directory">/var/lib/mandos</filename></term>
-	<listitem>
-	  <para>
-	    Directory where persistent state will be saved.  Change
-	    this with the <option>--statedir</option> option.  See
-	    also the <option>--no-restore</option> option.
-	  </para>
-	</listitem>
-      </varlistentry>
-      <varlistentry>
 	<term><filename>/dev/log</filename></term>
 	<listitem>
 	  <para>
@@ -529,12 +496,20 @@
       backtrace.  This could be considered a feature.
     </para>
     <para>
+      Currently, if a client is disabled due to having timed out, the
+      server does not record this fact onto permanent storage.  This
+      has some security implications, see <xref linkend="clients"/>.
+    </para>
+    <para>
       There is no fine-grained control over logging and debug output.
     </para>
     <para>
       Debug mode is conflated with running in the foreground.
     </para>
     <para>
+      The console log messages do not show a time stamp.
+    </para>
+    <para>
       This server does not check the expire time of clients’ OpenPGP
       keys.
     </para>
@@ -553,9 +528,9 @@
     <informalexample>
       <para>
 	Run the server in debug mode, read configuration files from
-	the <filename class="directory">~/mandos</filename> directory,
-	and use the Zeroconf service name <quote>Test</quote> to not
-	collide with any other official Mandos server on this host:
+	the <filename>~/mandos</filename> directory, and use the
+	Zeroconf service name <quote>Test</quote> to not collide with
+	any other official Mandos server on this host:
       </para>
       <para>
 
@@ -610,6 +585,21 @@
 	compromised if they are gone for too long.
       </para>
       <para>
+	If a client is compromised, its downtime should be duly noted
+	by the server which would therefore disable the client.  But
+	if the server was ever restarted, it would re-read its client
+	list from its configuration file and again regard all clients
+	therein as enabled, and hence eligible to receive their
+	passwords.  Therefore, be careful when restarting servers if
+	it is suspected that a client has, in fact, been compromised
+	by parties who may now be running a fake Mandos client with
+	the keys from the non-encrypted initial <acronym>RAM</acronym>
+	image of the client host.  What should be done in that case
+	(if restarting the server program really is necessary) is to
+	stop the server program, edit the configuration file to omit
+	any suspect clients, and restart the server program.
+      </para>
+      <para>
 	For more details on client-side security, see
 	<citerefentry><refentrytitle>mandos-client</refentrytitle>
 	<manvolnum>8mandos</manvolnum></citerefentry>.

=== modified file 'plugin-runner.c'
--- plugin-runner.c	2011-10-09 12:32:13 +0000
+++ plugin-runner.c	2011-07-16 00:29:19 +0000
@@ -2,8 +2,8 @@
 /*
  * Mandos plugin runner - Run Mandos plugins
  *
- * Copyright © 2008-2011 Teddy Hogeborn
- * Copyright © 2008-2011 Björn Påhlsson
+ * Copyright © 2008-2010 Teddy Hogeborn
+ * Copyright © 2008-2010 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as
@@ -19,7 +19,7 @@
  * along with this program.  If not, see
  * <http://www.gnu.org/licenses/>.
  * 
- * Contact the authors at <mandos@recompile.se>.
+ * Contact the authors at <mandos@fukt.bsnet.se>.
  */
 
 #define _GNU_SOURCE		/* TEMP_FAILURE_RETRY(), getline(),
@@ -79,7 +79,7 @@
 #define AFILE "/conf/conf.d/mandos/plugin-runner.conf"
 
 const char *argp_program_version = "plugin-runner " VERSION;
-const char *argp_program_bug_address = "<mandos@recompile.se>";
+const char *argp_program_bug_address = "<mandos@fukt.bsnet.se>";
 
 typedef struct plugin{
   char *name;			/* can be NULL or any plugin name */

=== modified file 'plugin-runner.xml'
--- plugin-runner.xml	2011-10-05 16:56:06 +0000
+++ plugin-runner.xml	2011-08-08 21:12:37 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "plugin-runner">
-<!ENTITY TIMESTAMP "2011-10-05">
+<!ENTITY TIMESTAMP "2011-08-08">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -19,14 +19,14 @@
 	<firstname>Björn</firstname>
 	<surname>Påhlsson</surname>
 	<address>
-	  <email>belorn@recompile.se</email>
+	  <email>belorn@fukt.bsnet.se</email>
 	</address>
       </author>
       <author>
 	<firstname>Teddy</firstname>
 	<surname>Hogeborn</surname>
 	<address>
-	  <email>teddy@recompile.se</email>
+	  <email>teddy@fukt.bsnet.se</email>
 	</address>
       </author>
     </authorgroup>
@@ -261,7 +261,7 @@
 	    Disable the plugin named
 	    <replaceable>PLUGIN</replaceable>.  The plugin will not be
 	    started.
-	  </para>
+	  </para>	
 	</listitem>
       </varlistentry>
       

=== modified file 'plugins.d/askpass-fifo.c'
--- plugins.d/askpass-fifo.c	2011-10-05 16:00:56 +0000
+++ plugins.d/askpass-fifo.c	2011-07-13 02:24:39 +0000
@@ -19,7 +19,7 @@
  * along with this program.  If not, see
  * <http://www.gnu.org/licenses/>.
  * 
- * Contact the authors at <mandos@recompile.se>.
+ * Contact the authors at <mandos@fukt.bsnet.se>.
  */
 
 #define _GNU_SOURCE		/* TEMP_FAILURE_RETRY() */

=== modified file 'plugins.d/askpass-fifo.xml'
--- plugins.d/askpass-fifo.xml	2011-10-05 16:00:56 +0000
+++ plugins.d/askpass-fifo.xml	2011-08-08 21:12:37 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "askpass-fifo">
-<!ENTITY TIMESTAMP "2011-10-03">
+<!ENTITY TIMESTAMP "2011-08-08">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>
@@ -19,14 +19,14 @@
 	<firstname>Björn</firstname>
 	<surname>Påhlsson</surname>
 	<address>
-	  <email>belorn@recompile.se</email>
+	  <email>belorn@fukt.bsnet.se</email>
 	</address>
       </author>
       <author>
 	<firstname>Teddy</firstname>
 	<surname>Hogeborn</surname>
 	<address>
-	  <email>teddy@recompile.se</email>
+	  <email>teddy@fukt.bsnet.se</email>
 	</address>
       </author>
     </authorgroup>

=== modified file 'plugins.d/mandos-client.c'
--- plugins.d/mandos-client.c	2011-10-05 16:00:56 +0000
+++ plugins.d/mandos-client.c	2011-08-07 14:49:02 +0000
@@ -26,7 +26,7 @@
  * along with this program.  If not, see
  * <http://www.gnu.org/licenses/>.
  * 
- * Contact the authors at <mandos@recompile.se>.
+ * Contact the authors at <mandos@fukt.bsnet.se>.
  */
 
 /* Needed by GPGME, specifically gpgme_data_seek() */
@@ -127,7 +127,7 @@
 bool debug = false;
 static const char mandos_protocol_version[] = "1";
 const char *argp_program_version = "mandos-client " VERSION;
-const char *argp_program_bug_address = "<mandos@recompile.se>";
+const char *argp_program_bug_address = "<mandos@fukt.bsnet.se>";
 static const char sys_class_net[] = "/sys/class/net";
 char *connect_to = NULL;
 

=== modified file 'plugins.d/mandos-client.xml'
--- plugins.d/mandos-client.xml	2011-10-05 16:00:56 +0000
+++ plugins.d/mandos-client.xml	2011-08-08 21:12:37 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos-client">
-<!ENTITY TIMESTAMP "2011-10-03">
+<!ENTITY TIMESTAMP "2011-08-08">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>
@@ -19,14 +19,14 @@
 	<firstname>Björn</firstname>
 	<surname>Påhlsson</surname>
 	<address>
-	  <email>belorn@recompile.se</email>
+	  <email>belorn@fukt.bsnet.se</email>
 	</address>
       </author>
       <author>
 	<firstname>Teddy</firstname>
 	<surname>Hogeborn</surname>
 	<address>
-	  <email>teddy@recompile.se</email>
+	  <email>teddy@fukt.bsnet.se</email>
 	</address>
       </author>
     </authorgroup>

=== modified file 'plugins.d/password-prompt.c'
--- plugins.d/password-prompt.c	2011-10-09 12:32:13 +0000
+++ plugins.d/password-prompt.c	2011-07-27 17:58:27 +0000
@@ -2,8 +2,8 @@
 /*
  * Password-prompt - Read a password from the terminal and print it
  * 
- * Copyright © 2008-2011 Teddy Hogeborn
- * Copyright © 2008-2011 Björn Påhlsson
+ * Copyright © 2008-2010 Teddy Hogeborn
+ * Copyright © 2008-2010 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as
@@ -19,7 +19,7 @@
  * along with this program.  If not, see
  * <http://www.gnu.org/licenses/>.
  * 
- * Contact the authors at <mandos@recompile.se>.
+ * Contact the authors at <mandos@fukt.bsnet.se>.
  */
 
 #define _GNU_SOURCE		/* getline(), asprintf() */
@@ -67,7 +67,7 @@
 int signal_received;
 bool debug = false;
 const char *argp_program_version = "password-prompt " VERSION;
-const char *argp_program_bug_address = "<mandos@recompile.se>";
+const char *argp_program_bug_address = "<mandos@fukt.bsnet.se>";
 
 /* Needed for conflict resolution */
 const char plymouth_name[] = "plymouthd";

=== modified file 'plugins.d/password-prompt.xml'
--- plugins.d/password-prompt.xml	2011-10-05 16:00:56 +0000
+++ plugins.d/password-prompt.xml	2011-08-08 21:12:37 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "password-prompt">
-<!ENTITY TIMESTAMP "2011-10-03">
+<!ENTITY TIMESTAMP "2011-08-08">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>
@@ -19,14 +19,14 @@
 	<firstname>Björn</firstname>
 	<surname>Påhlsson</surname>
 	<address>
-	  <email>belorn@recompile.se</email>
+	  <email>belorn@fukt.bsnet.se</email>
 	</address>
       </author>
       <author>
 	<firstname>Teddy</firstname>
 	<surname>Hogeborn</surname>
 	<address>
-	  <email>teddy@recompile.se</email>
+	  <email>teddy@fukt.bsnet.se</email>
 	</address>
       </author>
     </authorgroup>

=== modified file 'plugins.d/plymouth.c'
--- plugins.d/plymouth.c	2011-10-05 16:00:56 +0000
+++ plugins.d/plymouth.c	2011-07-13 02:24:39 +0000
@@ -19,7 +19,7 @@
  * along with this program.  If not, see
  * <http://www.gnu.org/licenses/>.
  * 
- * Contact the authors at <mandos@recompile.se>.
+ * Contact the authors at <mandos@fukt.bsnet.se>.
  */
 
 #define _GNU_SOURCE		/* asprintf(), TEMP_FAILURE_RETRY() */
@@ -54,17 +54,15 @@
 #include <stdarg.h>		/* va_list, va_start(), ... */
 
 sig_atomic_t interrupted_by_signal = 0;
-
-/* Used by Ubuntu 11.04 (Natty Narwahl) */
-const char plymouth_old_pid[] = "/dev/.initramfs/plymouth.pid";
-/* Used by Ubuntu 11.10 (Oneiric Ocelot) */
-const char plymouth_pid[] = "/run/initramfs/plymouth.pid";
-
+const char plymouth_pid[] = "/dev/.initramfs/plymouth.pid";
 const char plymouth_path[] = "/bin/plymouth";
 const char plymouthd_path[] = "/sbin/plymouthd";
 const char *plymouthd_default_argv[] = {"/sbin/plymouthd",
 					"--mode=boot",
 					"--attach-to-session",
+					"--pid-file="
+					"/dev/.initramfs/"
+					"plymouth.pid",
 					NULL };
 
 static void termination_handler(__attribute__((unused))int signum){
@@ -262,9 +260,8 @@
 
 pid_t get_pid(void){
   int ret;
+  FILE *pidfile = fopen(plymouth_pid, "r");
   uintmax_t maxvalue = 0;
-  FILE *pidfile = fopen(plymouth_pid, "r");
-  /* Try the new pid file location */
   if(pidfile != NULL){
     ret = fscanf(pidfile, "%" SCNuMAX, &maxvalue);
     if(ret != 1){
@@ -272,18 +269,6 @@
     }
     fclose(pidfile);
   }
-  /* Try the old pid file location */
-  if(maxvalue == 0){
-    pidfile = fopen(plymouth_pid, "r");
-    if(pidfile != NULL){
-      ret = fscanf(pidfile, "%" SCNuMAX, &maxvalue);
-      if(ret != 1){
-	maxvalue = 0;
-      }
-      fclose(pidfile);
-    }
-  }
-  /* Look for a plymouth process */
   if(maxvalue == 0){
     struct dirent **direntries = NULL;
     ret = scandir("/proc", &direntries, is_plymouth, alphasort);

=== modified file 'plugins.d/plymouth.xml'
--- plugins.d/plymouth.xml	2011-10-05 16:00:56 +0000
+++ plugins.d/plymouth.xml	2011-08-08 21:12:37 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "plymouth">
-<!ENTITY TIMESTAMP "2011-10-03">
+<!ENTITY TIMESTAMP "2011-08-08">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>
@@ -19,14 +19,14 @@
 	<firstname>Björn</firstname>
 	<surname>Påhlsson</surname>
 	<address>
-	  <email>belorn@recompile.se</email>
+	  <email>belorn@fukt.bsnet.se</email>
 	</address>
       </author>
       <author>
 	<firstname>Teddy</firstname>
 	<surname>Hogeborn</surname>
 	<address>
-	  <email>teddy@recompile.se</email>
+	  <email>teddy@fukt.bsnet.se</email>
 	</address>
       </author>
     </authorgroup>

=== modified file 'plugins.d/splashy.c'
--- plugins.d/splashy.c	2011-10-05 16:00:56 +0000
+++ plugins.d/splashy.c	2011-07-13 02:24:39 +0000
@@ -19,7 +19,7 @@
  * along with this program.  If not, see
  * <http://www.gnu.org/licenses/>.
  * 
- * Contact the authors at <mandos@recompile.se>.
+ * Contact the authors at <mandos@fukt.bsnet.se>.
  */
 
 #define _GNU_SOURCE		/* TEMP_FAILURE_RETRY(), asprintf() */

=== modified file 'plugins.d/splashy.xml'
--- plugins.d/splashy.xml	2011-10-05 16:00:56 +0000
+++ plugins.d/splashy.xml	2011-08-08 21:12:37 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "splashy">
-<!ENTITY TIMESTAMP "2011-10-03">
+<!ENTITY TIMESTAMP "2011-08-08">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>
@@ -19,14 +19,14 @@
 	<firstname>Björn</firstname>
 	<surname>Påhlsson</surname>
 	<address>
-	  <email>belorn@recompile.se</email>
+	  <email>belorn@fukt.bsnet.se</email>
 	</address>
       </author>
       <author>
 	<firstname>Teddy</firstname>
 	<surname>Hogeborn</surname>
 	<address>
-	  <email>teddy@recompile.se</email>
+	  <email>teddy@fukt.bsnet.se</email>
 	</address>
       </author>
     </authorgroup>

=== modified file 'plugins.d/usplash.c'
--- plugins.d/usplash.c	2011-10-05 16:00:56 +0000
+++ plugins.d/usplash.c	2011-07-13 02:24:39 +0000
@@ -19,7 +19,7 @@
  * along with this program.  If not, see
  * <http://www.gnu.org/licenses/>.
  * 
- * Contact the authors at <mandos@recompile.se>.
+ * Contact the authors at <mandos@fukt.bsnet.se>.
  */
 
 #define _GNU_SOURCE		/* asprintf(), TEMP_FAILURE_RETRY() */

=== modified file 'plugins.d/usplash.xml'
--- plugins.d/usplash.xml	2011-10-05 16:00:56 +0000
+++ plugins.d/usplash.xml	2011-08-08 21:12:37 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "usplash">
-<!ENTITY TIMESTAMP "2011-10-03">
+<!ENTITY TIMESTAMP "2011-08-08">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>
@@ -19,14 +19,14 @@
 	<firstname>Björn</firstname>
 	<surname>Påhlsson</surname>
 	<address>
-	  <email>belorn@recompile.se</email>
+	  <email>belorn@fukt.bsnet.se</email>
 	</address>
       </author>
       <author>
 	<firstname>Teddy</firstname>
 	<surname>Hogeborn</surname>
 	<address>
-	  <email>teddy@recompile.se</email>
+	  <email>teddy@fukt.bsnet.se</email>
 	</address>
       </author>
     </authorgroup>

